/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */

/**
 * Classes that must be notified when a SpiTran project file has been opened
 * must implement this interface. When this happens each registered listener
 * will have it's getDB() method called. At this point data should be loaded
 * in from files.
 *
 * @author Anish Malhotra, Cadence Design Systems
 * @see s2iDBReadWrite
 */

interface s2iDBOpenListener{
 public abstract void getDB();
}
