/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */

import javax.swing.*;
import java.awt.*;
import javax.swing.JFrame;
import javax.swing.filechooser.FileFilter;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;

/**
 * A window for choosing the location of a new SpiTran project. Once complete,
 * the s2iProjectSetup() window is invoked.
 *
 * @author Anish Malhotra, Cadence Design Systems
 * @see s2iProjectSetup
 */
public class s2iNewProject extends javax.swing.JFrame
{
/**
* The name of the new project directory (not the full path)
*/
  static StringBuffer ProjDirBuf = new StringBuffer("");
/**
* The directory in which the new project directory will be created
*/
  static StringBuffer LocationBuf = new StringBuffer("");

/**
* Default constructor sets many defaults.
*/
	public s2iNewProject()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("New Project Directory");
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		getContentPane().setLayout(gridBagLayout);
		setVisible(false);
		setSize(420,169);
		setBackground(new Color(-3355444));
		jNameLabel = new javax.swing.JLabel();
		jNameLabel.setText("Name:");
		jNameLabel.setBounds(5,24,292,15);
		jNameLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNameLabel.setForeground(new Color(0));
		jNameLabel.setBackground(new Color(-3355444));
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.95;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,5,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jNameLabel, gbc);
		getContentPane().add(jNameLabel);
		jNameField = new javax.swing.JTextField();
		jNameField.setMargin(new java.awt.Insets(0,0,0,0));
		jNameField.setBounds(5,43,292,19);
		jNameField.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jNameField.setForeground(new Color(0));
		jNameField.setBackground(new Color(16777215));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 0.95;
		gbc.anchor = GridBagConstraints.NORTH;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(1,5,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jNameField, gbc);
		getContentPane().add(jNameField);
		jLocLabel = new javax.swing.JLabel();
		jLocLabel.setText("Location: ");
		jLocLabel.setBounds(5,116,292,15);
		jLocLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLocLabel.setForeground(new Color(0));
		jLocLabel.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.weightx = 0.95;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(20,5,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jLocLabel, gbc);
		getContentPane().add(jLocLabel);
		jLocTextField = new javax.swing.JTextField();
		jLocTextField.setMargin(new java.awt.Insets(0,0,0,0));
		jLocTextField.setAlignmentX(0.0F);
		jLocTextField.setBounds(5,136,292,19);
		jLocTextField.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jLocTextField.setForeground(new Color(0));
		jLocTextField.setBackground(new Color(16777215));
		gbc = new GridBagConstraints();
		gbc.gridy = 4;
		gbc.gridwidth = 2;
		gbc.weightx = 0.95;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(5,5,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jLocTextField, gbc);
		getContentPane().add(jLocTextField);
		jCreateButton = new javax.swing.JButton();
		jCreateButton.setText("Create...");
		jCreateButton.setActionCommand("Create...");
		jCreateButton.setBounds(317,17,97,25);
		jCreateButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jCreateButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 15;
		gbc.gridy = 0;
		gbc.weightx = 0.05;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(5,20,0,5);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jCreateButton, gbc);
		getContentPane().add(jCreateButton);
		jCancelButton = new javax.swing.JButton();
		jCancelButton.setText(" Cancel  ");
		jCancelButton.setActionCommand(" Cancel  ");
		jCancelButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jCancelButton.setBounds(317,44,97,25);
		jCancelButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jCancelButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 15;
		gbc.gridy = 1;
		gbc.weightx = 0.05;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(2,20,0,5);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jCancelButton, gbc);
		getContentPane().add(jCancelButton);
		jBrowseButton = new javax.swing.JButton();
		jBrowseButton.setText("Browse...");
		jBrowseButton.setActionCommand("Browse...");
		jBrowseButton.setBounds(317,131,97,25);
		jBrowseButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jBrowseButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 15;
		gbc.gridy = 4;
		gbc.weightx = 0.05;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,20,0,5);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jBrowseButton, gbc);
		getContentPane().add(jBrowseButton);
		//}}

		//{{ Non-symantec init controls - anish

                LookAndFeel LnF = UIManager.getLookAndFeel();
                if (LnF.getName().endsWith("Motif"))
                {
                   // System.out.println(LnF.getName());
                   // System.out.println(LnF.toString());
                   /* ********************************************************
                    * Ideally, there should not be platform or L&F specific  *
                    * code in Java. But, in this case, the vertical spacing  *
                    * between "Create" and "Cancel" buttons was not          *
                    * aesthetic in Motif in spite of being OK in Windows and *
                    * Metal. Hence a need to change the Grid bag constraints *
                    * here. - anish 19th Feb '99.                            *
                    *********************************************************/
                    gbc =   ((GridBagLayout)getContentPane().getLayout()).getConstraints(jCancelButton);
                    gbc.insets.top = -10;
                    ((GridBagLayout)getContentPane().getLayout()).setConstraints( jCancelButton , gbc);
                }
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		s2iWindowAdapter aWindowAdapter = new s2iWindowAdapter();
		this.addWindowListener(aWindowAdapter);
		s2iActionListener lActionListener = new s2iActionListener();
		jCreateButton.addActionListener(lActionListener);
		jCancelButton.addActionListener(lActionListener);
		jBrowseButton.addActionListener(lActionListener);
        jNameField.addActionListener(lActionListener);
		//}}

		//{{Non-symantec code - anish 8Oct98
		String pwd = System.getProperty("user.dir");
		jLocTextField.setText(pwd);
		LocationBuf.setLength(0);
		LocationBuf.append(pwd);

		//}}
	}

/**
* Constructor with a specified window title.
*/
	public s2iNewProject(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

/**
* Constructor with a specified parent window.
*/
  public s2iNewProject(java.awt.Component parent)
	{
		this();
		this.parent = parent;
		parent.setEnabled(false);
	}

/**
 * Set the window visibility, resetting the winidow location when it
 * becomes visible.
 * @param b true if the window should become visible
 */
  public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

/**
 * Test the s2iNewProject window. Only creates the directory.
 * @param args unused
 */
	static public void main(String args[])
	{
		(new s2iNewProject()).setVisible(true);
	}

/**
 * Call the superclass addNotify method, then adjust the layout.
 */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	/** Has the window layout been adjusted? */
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JLabel jNameLabel;
	javax.swing.JTextField jNameField;
	javax.swing.JLabel jLocLabel;
	javax.swing.JTextField jLocTextField;
	javax.swing.JButton jCreateButton;
	javax.swing.JButton jCancelButton;
	javax.swing.JButton jBrowseButton;
	//}}

	//{{Non-symantec CONTROLS
	java.awt.Component parent = null;
	//}}

	//{{DECLARE_MENUS
	//}}

/**
 * A class for handling window events
 */
	class s2iWindowAdapter extends java.awt.event.WindowAdapter
	{
/**
 * Handle a window event
 * @param event The event to handle
 */
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iNewProject.this)
				JFrame1_WindowClosing(event);
		}
	}

/**
 * Close the window. If there is no parent window, then quit the application.
 * param event The event triggering the closing (unused)
 */
	void JFrame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		if (parent == null)
 	        System.exit(0);    // close the application
		else
	        parent.setEnabled(true);
	}

/**
 * A class for handling button and field events
 */
	class s2iActionListener implements java.awt.event.ActionListener
	{
/**
 * Handle a button event
 * @param event The event to handle
 */
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jCreateButton)
				jCreateButton_actionPerformed(event);
			else if (object == jCancelButton)
				jCancelButton_actionPerformed(event);
			else if (object == jBrowseButton)
				jBrowseButton_actionPerformed(event);
		}
	}

/**
 * Create the new project. A number of checks are made first. The Project
 * Setup window is then invoked.
 * param event The event triggering the action (unused)
 */
	void jCreateButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		String ProjName = jNameField.getText();

		/* check that the Location is valid */
		boolean LocOK = LocVerify();

		/* check that the ProjectName is a valid name. It should
		not have any special characters - only-spaces, file separator. */
		boolean ProjNameOK = true;
		if (ProjName.trim().equals(""))
		   ProjNameOK = false;
		try
		{
		   char c;
		   int len = ProjName.length();
		   for (int i=0; i < len ; i++)
		   {
		       c = ProjName.charAt(i);
		       if (! java.lang.Character.isJavaIdentifierPart(c))
		       {
		           ProjNameOK = false;
		           break;
		       }
		   }
		}
		catch (java.lang.StringIndexOutOfBoundsException e)
		{
		    s2iError.PrintMsg(
              "Error - Project Name out of Bounds. Failed to create project.",
              s2iError.ERR | s2iError.POPUP | s2iError.LOG, s2iError.DISPLAY,
              null);
		}

		//if Project Name is not OK an error is to be displayed
		if (!ProjNameOK)
		{
		    //s2iError err = new s2iError();
		    //err.PrintMsg("This is not a valid project Name", err.ERR, err.LOG | err.POPUP,
		    //             this);
		    JOptionPane.showMessageDialog(this, "This is not a valid project Name",
		        "SpiTran", JOptionPane.ERROR_MESSAGE);
		}

		//Make the Project workspace
		if (LocOK && ProjNameOK)
		{
		    s2iGlobals.ProjName = ProjName;
		    ProjDirBuf.setLength(0);
		    ProjDirBuf.append(LocationBuf + java.io.File.separator + ProjName);
		    s2iGlobals.ProjDirFile = new java.io.File(new String(ProjDirBuf));
		    s2iGlobals.ProjDirFile.mkdir();

		    setVisible(false); // hide the Frame
		    dispose();	      // free the system resources
		    (new s2iProjectSetup(parent, true)).setVisible(true);

		}
	}

/**
 * Check a directory to see if we can create a new project directory in it.
 * @return true if a project directory can be created
 */
	boolean LocVerify()
	{
		String relDirStr, absDirStr;
		java.io.File relDirFile;
		boolean dirPathOK = true;

		relDirStr = jLocTextField.getText();
		relDirFile = new java.io.File(relDirStr);
		if (!relDirFile.isDirectory())
		{
		   ;  // Message for "Dir does not exist"
		   dirPathOK = false;
		   JOptionPane.showMessageDialog(this, "The location does not exist",
		        "SpiTran", JOptionPane.ERROR_MESSAGE);
		}
		if ((dirPathOK) && !relDirFile.canWrite())
		{
		   ;  //Message for "Dir not writable"
		   dirPathOK = false;
		   JOptionPane.showMessageDialog(this, "The Location is not writable",
		        "SpiTran", JOptionPane.ERROR_MESSAGE);
		}

		if (dirPathOK)
		{
		    absDirStr = relDirFile.getAbsolutePath();
		    jLocTextField.setText(absDirStr);
		    LocationBuf.setLength(0);
		    LocationBuf.append(absDirStr);
		}
		else
		{// restore the previous value of the field
		    jLocTextField.setText(new String(LocationBuf));
		}

		return(dirPathOK);
	}

/**
 * Close the window with no further action.
 * @param event The event triggering the cancel (unused)
 */
	void jCancelButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		java.awt.AWTEvent e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
		dispatchEvent(e);
	}

/**
 * Use a JFileChooser to allow the user to choose the directory in which the
 * new project directory will be created. Only a directory may be chosen.
 * @param event The event triggering the browse (unused)
 */
    void jBrowseButton_actionPerformed(java.awt.event.ActionEvent event)
    {
        String location = jLocTextField.getText();
        JFileChooser dirBrowser = new JFileChooser(location.length() > 0 ? location : ".");
	  dirBrowser.setDialogTitle("Project Directory");
	  dirBrowser.setFileFilter(new dirFilter());
	  dirBrowser.showDialog(this, "  OK  ");
        try{
            location = dirBrowser.getSelectedFile().getCanonicalPath();
        } catch(java.io.IOException ioe)
        {
            location = dirBrowser.getSelectedFile().getAbsolutePath();
        }
        if (location != null)
        {
            jLocTextField.setText(location);
        }
    }

/**
 * A FileFilter class to make a JFileChooser choose only directories.
 */
   class dirFilter extends FileFilter
   {
/**
 * Get the description String for SpiTran directories in a JFileChooser
 */
      public String getDescription()
      {
        return("SpiTran - Directory filter");
      }

/**
 * Determine if a file entry should be shown in a JFileChooser. Only directories
 * are shown.
 * @param f The file to accept or reject
 * @return true if the file should be shown
 */
      public boolean accept(java.io.File f)
      {
         return (f.isDirectory());
      }
   }
}

