/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */

import javax.swing.*;
import java.awt.*;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;
import java.util.Enumeration;
import javax.swing.JFrame;
import javax.swing.border.*;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.JScrollPane;
import javax.swing.BorderFactory;
import javax.swing.tree.*;

/**
 * A window for collecting basic information needed to start a project.
 *
 * @author Anish Malhotra, Cadence Design Systems
 */
public class s2iProjectSetup extends javax.swing.JFrame implements s2iDBOpenListener
{
/**
 * Construct the window class with default window title.
 */
	public s2iProjectSetup()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("SpiTran Project Setup");
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		getContentPane().setLayout(gridBagLayout);
		setVisible(false);
		setSize(529,337);
		setBackground(new Color(-3355444));
		jLabel1 = new javax.swing.JLabel();
		jLabel1.setText("Buffer Technology:");
		jLabel1.setBounds(16,10,129,15);
		jLabel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLabel1.setForeground(new Color(0));
		jLabel1.setBackground(new Color(-3355444));
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,15,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jLabel1, gbc);
		getContentPane().add(jLabel1);
		jImportLabel = new javax.swing.JLabel();
		jImportLabel.setText("Import SPICE File to Project Directory");
		jImportLabel.setToolTipText("Copies the specified SPICE file into the Project directory");
		jImportLabel.setBounds(175,10,248,15);
		jImportLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jImportLabel.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.weightx = 0.8;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,30,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jImportLabel, gbc);
		getContentPane().add(jImportLabel);
		jImportField = new javax.swing.JTextField();
		jImportField.setMargin(new java.awt.Insets(0,0,0,0));
		jImportField.setBounds(175,28,248,19);
		jImportField.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jImportField.setForeground(new Color(0));
		jImportField.setBackground(new Color(16777215));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.gridwidth = 2;
		gbc.weightx = 0.8;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,30,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jImportField, gbc);
		getContentPane().add(jImportField);
		jSPICEBrowseButton = new javax.swing.JButton();
		jSPICEBrowseButton.setText("Browse...");
		jSPICEBrowseButton.setActionCommand("Browse...");
		jSPICEBrowseButton.setBounds(428,25,85,25);
		jSPICEBrowseButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jSPICEBrowseButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 3;
		gbc.gridy = 1;
		gbc.weightx = 0.01;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,5,0,15);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jSPICEBrowseButton, gbc);
		getContentPane().add(jSPICEBrowseButton);
		borderPanel1 = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		borderPanel1.setLayout(gridBagLayout);
		borderPanel1.setBounds(1,50,527,262);
		borderPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.gridwidth = 4;
		gbc.weighty = 0.9;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(borderPanel1, gbc);
		getContentPane().add(borderPanel1);
		jTypeLabel = new javax.swing.JLabel();
		jTypeLabel.setText("Show Models of Type");
		jTypeLabel.setBounds(204,3,120,15);
		jTypeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTypeLabel.setForeground(new Color(0));
		jTypeLabel.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 0;
		gbc.weightx = 0.01;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,5);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jTypeLabel, gbc);
		borderPanel1.add(jTypeLabel);
		TypeChoice = new java.awt.Choice();
		TypeChoice.addItem("Typ");
		TypeChoice.addItem("Worst");
		TypeChoice.addItem("Best");
		try {
			TypeChoice.select(0);
		}
		catch (IllegalArgumentException e) { }
		TypeChoice.setBounds(332,0,60,21);
		gbc = new GridBagConstraints();
		gbc.gridx = 3;
		gbc.gridy = 0;
		gbc.weightx = 0.01;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,3,0,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(TypeChoice, gbc);
		borderPanel1.add(TypeChoice);
		jModelLibLabel = new javax.swing.JLabel();
		jModelLibLabel.setText("Libraries");
		jModelLibLabel.setBounds(1,41,138,15);
		jModelLibLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModelLibLabel.setForeground(new Color(0));
		jModelLibLabel.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 0.2;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(20,0,0,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jModelLibLabel, gbc);
		borderPanel1.add(jModelLibLabel);
		jModelsLabel = new javax.swing.JLabel();
		jModelsLabel.setText("Models");
		jModelsLabel.setBounds(329,41,40,15);
		jModelsLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModelsLabel.setForeground(new Color(0));
		jModelsLabel.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 3;
		gbc.gridy = 1;
		gbc.weightx = 0.3;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(20,0,0,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jModelsLabel, gbc);
		borderPanel1.add(jModelsLabel);
		jAddModButton = new javax.swing.JButton();
		jAddModButton.setText("Add Model");
		jAddModButton.setActionCommand("Add Model");
		jAddModButton.setBounds(214,97,105,25);
		jAddModButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jAddModButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 3;
		gbc.weightx = 0.01;
		gbc.anchor = GridBagConstraints.SOUTH;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,0,10);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jAddModButton, gbc);
		borderPanel1.add(jAddModButton);
		jDelModelButton = new javax.swing.JButton();
		jDelModelButton.setText("Del Model");
		jDelModelButton.setActionCommand("Del Model");
		jDelModelButton.setBounds(214,179,105,25);
		jDelModelButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jDelModelButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 4;
		gbc.weightx = 0.01;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,0,10);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jDelModelButton, gbc);
		borderPanel1.add(jDelModelButton);
		invisibleButton1 = new javax.swing.JButton();
		invisibleButton1.setBounds(427,56,1,1);
        invisibleButton1.setEnabled(false);
        Border invisibleBorder1 = javax.swing.BorderFactory.createEmptyBorder();
        invisibleButton1.setBorder(invisibleBorder1);
		gbc = new GridBagConstraints();
		gbc.gridx = 3;
		gbc.gridy = 2;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,40,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(invisibleButton1, gbc);
		borderPanel1.add(invisibleButton1);
		jAddLibButton = new javax.swing.JButton();
		jAddLibButton.setText("o o o");
		jAddLibButton.setActionCommand("o o o");
		jAddLibButton.setToolTipText("To Add Model Libraries");
		jAddLibButton.setBounds(161,41,43,15);
		jAddLibButton.setFont(new Font("Dialog", Font.BOLD, 4));
		jAddLibButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.weightx = 0.05;
		gbc.anchor = GridBagConstraints.SOUTHEAST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jAddLibButton, gbc);
		borderPanel1.add(jAddLibButton);
		jLibScrollPane = new javax.swing.JScrollPane();
		jLibScrollPane.setOpaque(true);
		jLibScrollPane.setBounds(1,56,203,206);
		jLibScrollPane.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLibScrollPane.setForeground(new Color(0));
		jLibScrollPane.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.gridwidth = 2;
		gbc.gridheight = 3;
		gbc.weightx = 0.2;
		gbc.weighty = 0.9;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jLibScrollPane, gbc);
		borderPanel1.add(jLibScrollPane);
		jLibTree = new javax.swing.JTree();
		jLibTree.setShowsRootHandles(true);
		jLibTree.setBounds(0,0,188,165);
		jLibTree.setBackground(new Color(16777215));
		jLibScrollPane.getViewport().add(jLibTree);
		jModelScrollPane = new javax.swing.JScrollPane();
		jModelScrollPane.setOpaque(true);
		jModelScrollPane.setBounds(329,56,197,206);
		jModelScrollPane.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModelScrollPane.setForeground(new Color(0));
		jModelScrollPane.setBackground(new Color(-3355444));
		gbc = new GridBagConstraints();
		gbc.gridx = 3;
		gbc.gridy = 2;
		gbc.gridwidth = 3;
		gbc.gridheight = 3;
		gbc.weightx = 0.08;
		gbc.weighty = 0.9;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)borderPanel1.getLayout()).setConstraints(jModelScrollPane, gbc);
		borderPanel1.add(jModelScrollPane);
		jModelTree = new javax.swing.JTree();
		jModelTree.setShowsRootHandles(true);
		jModelTree.setBounds(0,0,193,165);
		jModelTree.setBackground(new Color(16777215));
		jModelScrollPane.getViewport().add(jModelTree);
		jOKButton = new javax.swing.JButton();
		jOKButton.setText("  OK  ");
		jOKButton.setActionCommand("OK");
		jOKButton.setBounds(41,312,63,25);
		jOKButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jOKButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 4;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jOKButton, gbc);
		getContentPane().add(jOKButton);
		jCancelButton = new javax.swing.JButton();
		jCancelButton.setText("Cancel");
		jCancelButton.setActionCommand("Cancel");
		jCancelButton.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		jCancelButton.setBounds(145,312,73,25);
		jCancelButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jCancelButton.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 4;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jCancelButton, gbc);
		getContentPane().add(jCancelButton);
		jComboBox1 = new javax.swing.JComboBox();
		jComboBox1.setBounds(16,25,129,24);
		jComboBox1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jComboBox1.setForeground(new Color(0));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 0.01;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,15,0,0);
		((GridBagLayout)getContentPane().getLayout()).setConstraints(jComboBox1, gbc);
		getContentPane().add(jComboBox1);

		//{{Non-symantec User code
		/* Code to initialize the UI */
		// Initialize the Library and Model Trees - anish 22 Oct 98

		TypModelTreeList = new TreeList("Typ Models");
		TypModelTreeList.setTree(jModelTree);
		BestModelTreeList = new TreeList("Best Models");
		WorstModelTreeList = new TreeList("Worst Models");
		
		TypLibTreeList = new LibTreeList("Typ Libraries");
		TypLibTreeList.setTree(jLibTree);
		BestLibTreeList = new LibTreeList("Best libraries");
		WorstLibTreeList = new LibTreeList("Worst Libraries");
		
		//Trying out JComboBox instead of AWT's choice
		jComboBox1.addItem("ECL");
		jComboBox1.addItem("CMOS");
		jComboBox1.addItem("NMOS");
		jComboBox1.addItem("PECL");
		jComboBox1.setSelectedItem("NMOS");
		
		// Create the border for Models
		borderPanel1.setBorder(BorderFactory.createTitledBorder("Models"));

                // Tweaking the Tree's UI through its renderer - anish 13 Nov 98
                {
                   DefaultTreeCellRenderer LibTreeRenderer = new DefaultTreeCellRenderer();
                   LibTreeRenderer.setBackgroundNonSelectionColor( jLibTree.getBackground());
                   LibTreeRenderer.setBackgroundSelectionColor( new Color(40,45,135));
                   LibTreeRenderer.setBorderSelectionColor( new Color(255,255,255));
                   LibTreeRenderer.setTextNonSelectionColor(new Color(0, 0, 0));
                   LibTreeRenderer.setTextSelectionColor(new Color(255, 255, 255));
                   LibTreeRenderer.setClosedIcon(new javax.swing.ImageIcon(
                        s2iGlobals.getImageDir() + "lib.gif"));
                   LibTreeRenderer.setOpenIcon(new javax.swing.ImageIcon(
                        s2iGlobals.getImageDir() + java.io.File.separator +
                        "libs.gif"));
                   jLibTree.setCellRenderer(LibTreeRenderer);
                }
                // Tweaking the Tree's UI through its renderer - anish 18 Nov 98
                {
                   DefaultTreeCellRenderer LibTreeRenderer = new DefaultTreeCellRenderer();
                   LibTreeRenderer.setBackgroundNonSelectionColor( jLibTree.getBackground());
                   LibTreeRenderer.setBackgroundSelectionColor( new Color(40,45,135));
                   LibTreeRenderer.setBorderSelectionColor( new Color(255,255,255));
                   LibTreeRenderer.setTextNonSelectionColor(new Color(0, 0, 0));
                   LibTreeRenderer.setTextSelectionColor(new Color(255, 255, 255));
                   LibTreeRenderer.setClosedIcon(new javax.swing.ImageIcon(
                        s2iGlobals.getImageDir() + java.io.File.separator +
                        "lib.gif"));
                   LibTreeRenderer.setOpenIcon(new javax.swing.ImageIcon(
                        s2iGlobals.getImageDir() + java.io.File.separator +
                        "libs.gif"));
                   jModelTree.setCellRenderer(LibTreeRenderer);
                }

		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		jSPICEBrowseButton.addActionListener(lSymAction);
		jAddLibButton.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		TypeChoice.addItemListener(lSymItem);
		jAddModButton.addActionListener(lSymAction);
		jDelModelButton.addActionListener(lSymAction);
		jOKButton.addActionListener(lSymAction);
		jCancelButton.addActionListener(lSymAction);
		//}}

		//{{ User defined LISTENERS
           treeDelListener OnTreeElemDelete = new treeDelListener();
           //Mapping the delete key to an action - anish 13 Nov 98
           {
              javax.swing.KeyStroke KS_Delete = 
                 javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_DELETE, 0, true);
              javax.swing.KeyStroke KS_BackSpace = 
                 javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_BACK_SPACE, 0, true);

              jLibTree.registerKeyboardAction(OnTreeElemDelete, null, KS_Delete, jLibTree.WHEN_FOCUSED);
              jLibTree.registerKeyboardAction(OnTreeElemDelete, null, KS_BackSpace, jLibTree.WHEN_FOCUSED);
              jModelTree.registerKeyboardAction(OnTreeElemDelete, null, KS_Delete, jLibTree.WHEN_FOCUSED);
              jModelTree.registerKeyboardAction(OnTreeElemDelete, null, KS_BackSpace, jLibTree.WHEN_FOCUSED);
           }
		//}}
	}

/**
 * Constructor with a specified window title.
 * @param sTitle The window title string
 */
	public s2iProjectSetup(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

/**
 * Calling this constructor disables the parent until
 * s2iProjectSetup's window is open. This constructor also has special
 * handling for new projects, to clear data from previously opened projects.
 * @param parent The parent window to block while opening
 * @param isNewProject true if this is a new project
 * Non-symantec constructor: anish 30 Jan 99
 */
	public s2iProjectSetup(java.awt.Component parent, boolean isNewProject)
	{
	    this();
	    if (parent != null)
	       parent.setEnabled(false); //This will be set to true in the handler of
	                                // windowClosing.

	    this.parent = parent;
	    this.newProject = isNewProject;

	    // Read the data into the setup form

	    /* The SPICE file can not be changed. So disable that field
	     * Otherwise how will the table be updated, how will the nodeNames
	     * be updated. Either we lose that data, or the project will be
	     * out of sync because nodes and circuits being  shown will not
	     * belong to that file.
	     * And now, if the user has to enter everything afresh - better
	     * he start a new project
	     * SO I AM DISABLING THE IMPORT OF SPICE FILE Field.
	     * Note: It is necessary to provide the correct path to ensure
	     *       that the file-existence check passes on press of OK.
	     */
	     if (!isNewProject)
	     {
	        jSPICEBrowseButton.setEnabled(false);
	        jImportField.setText(s2iGlobals.ProjDirFile +
	                     java.io.File.separator +s2iGlobals.spiceFileName);
	        jImportField.setEnabled(false);
	     }
             else
	     {
	        /* If the project is a new Project, let's reset the globals *
	         * This takes care of the case when a New project is being  *
	         * opened while working on an existing one.                 *
	         */
	         s2iGlobals.gTypLibTreeList.setSize(0);
	         s2iGlobals.gBestLibTreeList.setSize(0);
	         s2iGlobals.gWorstLibTreeList.setSize(0);
	         s2iGlobals.gTypModelTreeList.setSize(0);
	         s2iGlobals.gBestModelTreeList.setSize(0);
	         s2iGlobals.gWorstModelTreeList.setSize(0);
	         s2iGlobals.gInstanceVector.setSize(0);
	         s2iGlobals.gConfigVector.setSize(0);
	         s2iDBReadWrite.fireDBOpenEvent();
	     }
	}

/**
 * Show the window. This resets the window location before calling the
 * superclass.
 *
 * @param b true or false for visibility.
 */
	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
		/* Non-symantec code
		 * Get the values from the DB; and register as DB open listener
		 * Stay DB open listener till this form is alive
		 */
		if (b)
		{
		   getDB();
		   s2iDBReadWrite.addDBOpenListener(this);
		}
		else
		{
		   s2iDBReadWrite.removeDBOpenListener(this);
		}
	}

/**
 * Test the s2iProjectSetup window. Only shows the window.
 * @param args unused
 */
	static public void main(String args[])
	{
		//{{ Non-symantec code
		String os = System.getProperty("os.name");
		try {
		   if (os.equals("Windows NT"))
		   {
		      /* Get the Windows Look and Feel -anish 18Nov 98*/
		      UIManager.setLookAndFeel("javax.swing.plaf.windows.WindowsLookAndFeel");
		   }
		   else
		   {
		      /* Get the Motif Look and Feel -anish 12Nov 98*/
		      UIManager.setLookAndFeel("javax.swing.plaf.motif.MotifLookAndFeel");
		   }
		} catch (UnsupportedLookAndFeelException  exc1) {
		   System.err.println(exc1);
		} catch (Exception exc2) {
		   System.err.println(exc2);
		   System.err.println("Could not load LookAndFeel");
		}
		//}}
		(new s2iProjectSetup()).setVisible(true);
	}

/**
 * Call the superclass addNotify method, then adjust the layout.
 */
	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

/**
 * Has the layout been adjusted?
 */
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JLabel jLabel1;
	javax.swing.JLabel jImportLabel;
	javax.swing.JTextField jImportField;
	javax.swing.JButton jSPICEBrowseButton;
	javax.swing.JPanel borderPanel1;
	javax.swing.JLabel jTypeLabel;
	java.awt.Choice TypeChoice;
	javax.swing.JLabel jModelLibLabel;
	javax.swing.JLabel jModelsLabel;
	javax.swing.JButton jAddModButton;
	javax.swing.JButton jDelModelButton;
    /**
     * An invisible button to work around problems resizing the window.
     * This button can not be seen, but it forces the layout manager to
     * reposition and resize objects correctly when the window is resized.
     */
	javax.swing.JButton invisibleButton1;
	javax.swing.JButton jAddLibButton;
	javax.swing.JScrollPane jLibScrollPane;
	javax.swing.JTree jLibTree;
	javax.swing.JScrollPane jModelScrollPane;
	javax.swing.JTree jModelTree;
	javax.swing.JButton jOKButton;
	javax.swing.JButton jCancelButton;
	javax.swing.JComboBox jComboBox1;
	//}}

	//{{Non-symantec controls
	TreeList TypModelTreeList, BestModelTreeList, WorstModelTreeList;
	LibTreeList TypLibTreeList, BestLibTreeList, WorstLibTreeList;
	java.awt.Component parent = null;
	boolean newProject = true;
	//}}

	//{{DECLARE_MENUS
	//}}

 /**
 * A class for handling window events
 */
	class SymWindow extends java.awt.event.WindowAdapter
	{
/**
 * Detect window closed events. Basically, pass them on.
 * @param event The event that triggered the call
 */
		public void windowClosed(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iProjectSetup.this)
				s2iProjectSetup_windowClosed(event);
		}

/**
 * Detect window closing events. Basically, pass them on.
 * @param event The event that triggered the call
 */
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iProjectSetup.this)
				JFrame1_WindowClosing(event);
		}
	}

/**
 * Quit the application when the main window closes.
 * @param event unused
 */
	void JFrame1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		if (parent == null)
		   System.exit(0);    // close the application
		else
		    parent.setEnabled(true);
	}

/**
 * A class for handling button events
 */
	class SymAction implements java.awt.event.ActionListener
	{
/**
 * Handle a button event.
 * @param event The event that triggered the call
 */
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jSPICEBrowseButton)
				jSPICEBrowseButton_actionPerformed(event);
			else if (object == jAddLibButton)
				jAddLibButton_actionPerformed(event);
			else if (object == jAddModButton)
				jAddModButton_actionPerformed(event);
			else if (object == jDelModelButton)
				jDelModelButton_actionPerformed(event);
			else if (object == jOKButton)
				jOKButton_actionPerformed(event);
			else if (object == jCancelButton)
				jCancelButton_actionPerformed(event);
		}
	}

/**
 * Have the user choose a Spice file
 * @param event The event that triggered the call
 */
	void jSPICEBrowseButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		// anish - 21 Oct 98
		JFileChooser importBrowser = new JFileChooser(".");
		importBrowser.showDialog(this, "Import SPICE");
		File selection = importBrowser.getSelectedFile();
		try
		{
		   jImportField.setText(selection.getCanonicalPath());
		}
		catch(java.io.IOException ioe)
		{
		   jImportField.setText(selection.getAbsolutePath());
		}
	}

    // Non-Symantec user defined function
    // anish 29 Oct 98
/**
 * Choose a TreeList based on the current ModelType..
 * @retval event The active model tree
 */
    TreeList getActiveModTreeList()
    {
        String ModelType = TypeChoice.getSelectedItem();
        if (ModelType.equals("Typ"))
           return(TypModelTreeList);
        else if (ModelType.equals("Best"))
           return(BestModelTreeList);
        else if (ModelType.equals("Worst"))
           return(WorstModelTreeList);

        return(null);

    }
    
    // Non-Symantec user define function
    // anish 29 Oct 98
    LibTreeList getActiveLibTreeList()
    {
        String ModelType = TypeChoice.getSelectedItem();
        if (ModelType.equals("Typ"))
           return(TypLibTreeList);
        else if (ModelType.equals("Best"))
           return(BestLibTreeList);
        else if (ModelType.equals("Worst"))
           return(WorstLibTreeList);

        return(null);
    }
    
/**
 * Have the user choose a Spice library file
 * @param event The event that triggered the call
 */
	void jAddLibButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		// anish -- 22 Oct 98
		JFileChooser importBrowser = new JFileChooser(".");
		importBrowser.showDialog(this, "Add Library");
		java.io.File selection = importBrowser.getSelectedFile();
                String selFileName;
		try
		{
		   selFileName = selection.getCanonicalPath();
		}
		catch(java.io.IOException ioe)
		{
		   selFileName = selection.getAbsolutePath();
		}

		// Add the selected Library to the Tree Model
		// Find current Tree list (depending on Show Model Of Type)
		/* Add the Library to the Tree List - here Lib will be parsed
		 * for all the Models it has, which will be added to the 
		 * corresponding Tree Model. */
		 try
		 {
		    getActiveLibTreeList().addElem(selFileName);
		 }
		 catch (java.io.FileNotFoundException FilNotFnd)
		 {
		    String Msg = new String("SPICE Library \"" + FilNotFnd.getMessage() +
		                             "\" does not exist");
		    s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP |
                               s2iError.LOG | s2iError.DISPLAY, this);
		 }
		 catch (java.io.IOException IOerr)
		 {
		    String Msg = new String("IO error in \"" + IOerr.getMessage()
		                             + "\"");
		    s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP |
		                     s2iError.LOG | s2iError.DISPLAY, this);
		 }
	}

	// Non-Symantec user defined class
	// anish 22 Oct 98
	class TreeList
	{
	    protected Vector list = new Vector();
	    protected DefaultMutableTreeNode rootNode;
	    protected DefaultTreeModel treeModel;
	    protected JTree tree;
	    protected Toolkit toolkit = Toolkit.getDefaultToolkit();
	    
	    public TreeList(String rootNodeName)
	    {
	        rootNode = new DefaultMutableTreeNode(rootNodeName);
	        this.treeModel = new DefaultTreeModel(rootNode);
	    }
	        
	    public void setTree(JTree t)
	    {
	        tree = t;
	        if (tree != null) tree.setModel(treeModel);
	    }
	    
	    public JTree getTree()
	    {
	        return(tree);
	    }
	    
	    public boolean contains(String elem)
	    {
	        boolean found = false;
	        Enumeration elemList = list.elements();
	        while (elemList.hasMoreElements() && (!found))
	        {
	            String curElem = (String) elemList.nextElement();
	            if (curElem.equals(elem))
	               found = true;
	        }
	        
	        return(found);
	    }
	    
	    public DefaultMutableTreeNode currentSelection()
	    {
	        if (tree == null) return(null);
	        
	        TreePath selection = tree.getSelectionPath();
	        DefaultMutableTreeNode selectNode=null;
	        if (selection != null)
	        {
	            selectNode = (DefaultMutableTreeNode) 
	                           selection.getLastPathComponent();
	        }
	        
	        return(selectNode);
	    }
	    
	    public DefaultMutableTreeNode[] currentSelections()
	    {
	        if (tree == null) return(null);
	        
	        TreePath[] selection = tree.getSelectionPaths();
	        DefaultMutableTreeNode[] selectNode=null;
	        if (selection != null)
	        {
                    selectNode = new DefaultMutableTreeNode[selection.length];
                    for (int i=0; i<selection.length; i++)
                    {
	               selectNode[i] = (DefaultMutableTreeNode) 
	                             selection[i].getLastPathComponent();
                    }
	        }
	        
	        return(selectNode);
	    }
	    
	    public void addElem(String newElem)
	        throws java.io.FileNotFoundException, java.io.IOException
	    {
	        if (!contains(newElem))
	        {
	           list.addElement(newElem);
	           DefaultMutableTreeNode newNode = new
	              DefaultMutableTreeNode(newElem);
	           treeModel.insertNodeInto(newNode, rootNode, 
	                                    rootNode.getChildCount());
	        }
	    }
	    
	    public void delSelectedElem()
	    {
	        String elem;
	        MutableTreeNode curNode= currentSelection();
	        if (curNode != null)
	        {
	           elem = curNode.toString();
	           if (this.contains(elem))
	           {
	              list.removeElement(elem);
	              MutableTreeNode parent = (MutableTreeNode)
	                                        curNode.getParent();
	              if (parent != null)
	              {
	                 treeModel.removeNodeFromParent(curNode);
	                 return;
	              }
	           }
	           
	        }
	        //Either there was no selection. or the root was
	        //selected
	        toolkit.beep();
	    }

	    public void removeAll()
	    {
		list.setSize(0);
		MutableTreeNode root = (MutableTreeNode) treeModel.getRoot();
		int numChild = root.getChildCount();
		for (int idx = 0; idx < numChild; idx ++)
		{
		   root.remove(idx);
		}
	    }

            //anish - 02 Dec 98
            /* Write down the LIBS and INCLUDES
            */
            public void writeToFile(String fname)
               throws java.io.IOException, java.lang.IndexOutOfBoundsException
            {
               writeToFile(fname, null);
            }
            
            //anish - 06 Apr 99
            /* Copy over the Strings provided by the caller in the file
             * before writing down the LIBS and INCLUDES
             */
            public void writeToFile(String fname, String prefix[])
               throws java.io.IOException, java.lang.IndexOutOfBoundsException
            {
               File outFile = new File(fname);
               // We'll overwrite this File
               if (outFile.exists()) 
                  outFile.delete();
               //Create the file for output
               BufferedWriter outFileWriter = new BufferedWriter(new FileWriter(outFile));
               
               // Copy the strings provoded by the caller
               if (prefix != null)
               {
                  int len = prefix.length;
                  for (int i=0; i<len; i++)
                  {
                    outFileWriter.write(prefix[i] + "\n");
                  }
               }
               
               // The elements to be written will be available in list
               int size = list.size();
               for (int i =0 ; i< size; i++)
               {
                 String LibNameWEntry = (String) list.elementAt(i);
                 outFileWriter.write(s2iGlobals.KWS_LIB + " " + LibNameWEntry + "\n");
               }
               outFileWriter.close();
            }
            
            public boolean isEmpty()
            {
                return(list.size() == 0);
            }

            public Object archive()
            {
               Object copy = list.clone();
               return(copy);
            }
	}
	
	// Non-Symantec user defined class
	// anish 28 Oct 98
	class LibTreeList extends TreeList
	{
	    public LibTreeList(String rootNodeName)
	    {
	        super(rootNodeName);
	    }
	    
	    public void addElem(String newElem)
	        throws java.io.FileNotFoundException, java.io.IOException
	    {
	        if (!contains(newElem))
	        {
	            DefaultMutableTreeNode LibNode, ModelNode;
	            int ctr = 0;
	            s2iLibReader LibReader = new s2iLibReader(newElem);
	            /* Parse the File "newElem" and get the Models included
	               therein */
	            //Enumeration EntryInLib = LibReader.getModelNames();
	            /* Parse the File "newElem" and get the Libs defined
	               therein */
	            Enumeration EntryInLib = LibReader.getEntryNames();
	            // this throws IOException if error in parsing the Lib "newElem"
	            // Make the Library name a Level 1 node
	            // Make all the Model names child of the newly created node.
	            // Add the Library node to the rootNode.
	            LibNode = new DefaultMutableTreeNode(newElem);
	            list.addElement(newElem);
	            treeModel.insertNodeInto(LibNode, rootNode, rootNode.getChildCount());
	            while (EntryInLib.hasMoreElements())
	            {
	                ModelNode = new DefaultMutableTreeNode((String) EntryInLib.nextElement());
	                treeModel.insertNodeInto(ModelNode, LibNode, ctr++);
	            }
	        }
                else
                {
                   String Msg = "Library " + newElem + "\nis already present";
                   s2iError.PrintMsg(Msg, s2iError.INFO, s2iError.POPUP
                                       , s2iProjectSetup.this);
                }
	    }
	    
	    public void delSelectedElem()
	    {
	        String elem;
	        DefaultMutableTreeNode curNode= currentSelection();
	        if (curNode != null)
	        {
	           elem = curNode.toString();
	           if (this.contains(elem) && (curNode.getLevel() ==1))
	           {
	              list.removeElement(elem);
	              treeModel.removeNodeFromParent(curNode);
	              return;
	           }
	        }
	        //Either there was no selection. or a node other than the
	        // Library was selected
	        toolkit.beep();
	    }

	} //End of class LibTreeList
	
	// Non-Symantec user defined class
	// anish 13 Nov 98
	class treeDelListener implements java.awt.event.ActionListener
	{
	   public void actionPerformed(java.awt.event.ActionEvent event)
	   {
	      Object object = event.getSource();
	      // Make appropriate call to jLibTree_delElem  and jModelTree_delElem
	      if (object == jLibTree)
	         jLibTree_delElem(event);
	      else if (object == jModelTree)
	         jModelTree_delElem(event);
	   }
	}

	// Non-Symantec user defined class
	// anish 13 Nov 98
	private void jLibTree_delElem(java.awt.event.ActionEvent event)
	{
	   getActiveLibTreeList().delSelectedElem();
	}

	// Non-Symantec user defined class
	// anish 13 Nov 98
	private void jModelTree_delElem(java.awt.event.ActionEvent event)
	{
	   getActiveModTreeList().delSelectedElem();
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == TypeChoice)
				TypeChoice_ItemStateChanged(event);
		}
	}

	void TypeChoice_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		// to do: code goes here.
		String ModelType = TypeChoice.getSelectedItem();
		if (ModelType.equals("Typ"))
		{
		   TypModelTreeList.setTree(jModelTree);
		   BestModelTreeList.setTree(null);
		   WorstModelTreeList.setTree(null);
		   
		   TypLibTreeList.setTree(jLibTree);
		   BestLibTreeList.setTree(null);
		   WorstLibTreeList.setTree(null);
		}
		else if (ModelType.equals("Best"))
		{
		   TypModelTreeList.setTree(null);
		   BestModelTreeList.setTree(jModelTree);
		   WorstModelTreeList.setTree(null);
		    
		   TypLibTreeList.setTree(null);
		   BestLibTreeList.setTree(jLibTree);
		   WorstLibTreeList.setTree(null);
		}
		else if (ModelType.equals("Worst"))
		{
		   TypModelTreeList.setTree(null);
		   BestModelTreeList.setTree(null);
		   WorstModelTreeList.setTree(jModelTree);
		   
		   TypLibTreeList.setTree(null);
		   BestLibTreeList.setTree(null);
		   WorstLibTreeList.setTree(jLibTree);
		}
	}

	void jAddModButton_actionPerformed(java.awt.event.ActionEvent event)
	{
           // to do: code goes here.
           /* anish -18 Nov '98
            * Add the entry LIBRARY'MODEL to the Models
            */
         Toolkit toolkit = Toolkit.getDefaultToolkit();
         LibTreeList curLibTree = getActiveLibTreeList();
         TreeList curModTree = getActiveModTreeList();
         DefaultMutableTreeNode[] selectNode = curLibTree.currentSelections();
         if (selectNode != null)
            for (int i=0; i<selectNode.length; i++)
            {
               if (selectNode[i].getLevel() ==2)
               {
                  String elem = selectNode[i].toString(); 
                  String parent = selectNode[i].getParent().toString(); 
                  String newElem = "'" + parent + "' " + elem;
                  try {
                     curModTree.addElem(newElem);
                  } catch (java.io.FileNotFoundException FilNotFnd) {
                  } catch (java.io.IOException ioe) {
                  }
               }
               else 
               { 
                  toolkit.beep(); 
               }
            }
	}

	void jDelModelButton_actionPerformed(java.awt.event.ActionEvent event)
	{
           // to do: code goes here.
           TreeList curModTree = getActiveModTreeList();
           curModTree.delSelectedElem();
	}

        //{{ User functions

        private String audit(String auditFileName)
           throws java.io.FileNotFoundException, java.io.IOException
        {
           StringBuffer Msg = new StringBuffer();
           String Cmd= "";
           boolean redo = true;
           while (redo)
           {
              /*  ======================================================
               *  - All INCLUDES are traversed in depth and existence
               *    of the dependent files is checked for
               *    (anish 01 Dec 98)
               *  =====================================================*/
              Enumeration Includes = s2iSpiceReader.getIncludeFiles(auditFileName);
              boolean allExist = true;
              Vector missingLibs = new Vector();
              Vector missingIncl = new Vector();
              while (Includes.hasMoreElements())
              {
                 String tmpString = (String) Includes.nextElement();
                 boolean exist = true;
                 if ((new File(tmpString)).exists() &&
                     (new File(tmpString)).isFile())
                 {
                    exist = s2iSpiceReader.allLnI_Exist(tmpString, missingLibs, missingIncl);
                 }
                 else
                 {
                    exist = false;
                    missingIncl.addElement(tmpString);
                 }
                 if (!exist) allExist = false;
              }
              if (!allExist)
              {
                 Msg.append("Missing LIBS/INCLUDES detected \n");
                 Msg.append("Note: Any relative path in the imported SPICE File may have \n");
                 Msg.append("      to be updated with respect to the project directory \n");
                 if (!missingIncl.isEmpty())
                 {
                    Msg.append("Missing Includes \n");
                    Msg.append("================ \n");
                    int size = missingIncl.size();
                    for (int i=0; i< size; i++)
                    {
                       String Missing = "   " + (String) missingIncl.elementAt(i);
                       Msg.append( Missing + "\n");
                    }
                 }
                 if (!missingLibs.isEmpty())
                 {
                    Msg.append("Missing LIBS \n");
                    Msg.append("============ \n");
                    int size = missingLibs.size();
                    for (int i=0; i< size; i++)
                    {
                       String Missing = "   " + (String) missingLibs.elementAt(i);
                       Msg.append( Missing + "\n");
                    }
                 }
              }
     
     
              /*  ======================================================
               *  - The SPICE file gets parsed and any Errors/Warnings
               *    are reported. (with the option of Edit/cont/cancel)
               *    (anish  25 Nov 98)
               *  =====================================================*/
              s2iSpiceReader SpiceReader = new s2iSpiceReader(auditFileName);
              StringBuffer SpiceLine = new StringBuffer();
              Vector allLines = new Vector();
              boolean fstTime = true;
              
              while(SpiceReader.getSpiceLine(SpiceLine, allLines) != 0)
              {
                 char fstChar;
                 if (SpiceLine.toString().trim().length() > 0)
                    fstChar = SpiceLine.toString().trim().charAt(0);
                 else
                    fstChar = ' ';
                 if ((fstChar=='v')||(fstChar=='V')||
                     (fstChar=='i')||(fstChar=='I'))
                 {
                    if (fstTime)
                    {
                       fstTime = false;
                       Msg.append("WARNING: \n");
                       Msg.append("   Verify the following V or I statements to make sure that\n");
                       Msg.append("   the source are valid and not for analysis. Else comment\n");
                       Msg.append("   these out.\n");
                    }
                    int size = allLines.size();
                    for (int i=0; i< size; i++)
                    {
                       Msg.append( "      " + ((StringBuffer) allLines.elementAt(i)).toString());
                       Msg.append("\n");
                    }
                 }
              }
              SpiceReader.close();

              /****************************************************
               * Display the error msgs with the option of
               * Edit/cont/cancel.
               **************************************************/
              s2iAudit msgDisplayer = new s2iAudit();
              try{
                msgDisplayer.clearText();
              } catch (java.lang.Exception ex)
              {
                msgDisplayer.addText("*******************************************\n");
                msgDisplayer.addText("**  Auditing SPICE FILE: "+auditFileName+"\n");
                msgDisplayer.addText("*******************************************\n");
              }
              msgDisplayer.addText(Msg.toString());
              msgDisplayer.setFileName(auditFileName);
              msgDisplayer.setTitle("Audit of SPICE File: " + auditFileName);
              msgDisplayer.setModal(true);
              msgDisplayer.setVisible(true);
              Cmd = msgDisplayer.getValue();
              if (Cmd.equals("CONTINUE") || Cmd.equals("CANCEL"))
              {
                 s2iError.Debug(Cmd);
                 redo = false;
              }
              s2iError.PrintMsg(Msg.toString(), s2iError.INFO,
                                s2iError.LOG | s2iError.DISPLAY, null);
          }
          return(Cmd);
       }
        //}}

	void jOKButton_actionPerformed(java.awt.event.ActionEvent event)
	{
           // to do: code goes here.
           /* (anish  19 Nov 98)
            * The following is to be done on the press of OK button
            *  - The SPICE file gets copied into the project area.
            *  - All INCLUDES are traversed in depth and exitence
            *    of the dependent files is checked for
            *  - The SPICE file gets parsed and any Errors/Warnings
            *    are reported. (with the option of Edit/cont/cancel)
            *  - A new file gets created with appropriate LIB statements
            *  - Save the SPICE filename, the Lib names, and the Model 
            *    names that will finally be part of the SpiTran DB.
            *  - For new projects, list the available subcircuits in the
            *    SPICE file
            */

           /* =============================================================
            *  The SPICE file gets copied into the project area.
            * Any .LIB statements get commented during this copy operation
            * =============================================================*/

           File inFile = new File(jImportField.getText());
           File tmpFile= null;
           FileInputStream inFileStream;
           FileOutputStream outFileStream;
           byte Buffer[] = new byte[1024];
           String fileNameWPath, fileName, outFileNameWPath ="";
           try{
              inFileStream = new FileInputStream(inFile);
           } catch(java.io.FileNotFoundException FilNotFound)
           {
              String Msg = "Spice file \n" + inFile.toString() + " does not exist.";
              s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | s2iError.LOG | s2iError.DISPLAY, this);
              return; // This will make the user stay on the Project setup form
           }
           fileNameWPath = jImportField.getText();
           int len = fileNameWPath.length();
           int fileNameStart = fileNameWPath.lastIndexOf(java.io.File.separator);
           if (fileNameStart == -1) fileNameStart =0; else fileNameStart++;
           fileName = fileNameWPath.substring(fileNameStart, len);
           outFileNameWPath = (s2iGlobals.ProjDirFile == null) ? fileName :
                               s2iGlobals.ProjDirFile + java.io.File.separator + fileName;


           /* We need to create a temporay file to copy the data. It helps
            * in covering up the case when the source file and the destination
            * files are same. It's difficult pointing out this case because
            * links can complicate the matter
            */
           //Create the temporary file
           if (newProject)
           {
               try{
                  /* This API for temp file creation should be activated for JDK1.2
                   * tmpFile = java.io.File.createTempFile(s2iGlobals.TMP_FILE_PREFIX, s2iGlobals.TMP_FILE_SUFFIX); 
                   */
                  int num = (int) Runtime.getRuntime().freeMemory() % 5000;
                  String tmpFileName = (s2iGlobals.ProjDirFile == null) ?
                      s2iGlobals.TMP_FILE_PREFIX + num + s2iGlobals.TMP_FILE_SUFFIX :
                      s2iGlobals.ProjDirFile + java.io.File.separator + s2iGlobals.TMP_FILE_PREFIX
                      + num + s2iGlobals.TMP_FILE_SUFFIX;
                  tmpFile = new File(tmpFileName);
                  while (tmpFile.exists())
                  {
                     tmpFileName = (s2iGlobals.ProjDirFile == null) ?
                         s2iGlobals.TMP_FILE_PREFIX + num + s2iGlobals.TMP_FILE_SUFFIX :
                         s2iGlobals.ProjDirFile + java.io.File.separator + s2iGlobals.TMP_FILE_PREFIX
                         + num + s2iGlobals.TMP_FILE_SUFFIX;
                     tmpFile = new File(tmpFileName);
                  }
                  new java.io.FileWriter(tmpFile);
                  new java.io.BufferedWriter(new java.io.FileWriter(tmpFile));
                  outFileStream = new FileOutputStream(tmpFile);
               } catch (java.lang.Exception ex)
               {
                  String Msg = "File Import Failure. Error in creating \n";
                  Msg += "a temporary file";
                  s2iError.PrintMsg(ex.toString(), s2iError.ERR, s2iError.LOG | s2iError.DISPLAY, this);
                  s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | s2iError.LOG | s2iError.DISPLAY, this);
                  return; // This will make the user stay on the Project setup form
               } 
               // Copy data to the temporary file
               try {
                  int bytesRead =0;
                  String Msg ="Copy " + fileName + " to the temporary File " + tmpFile.toString();
                  s2iError.Debug(Msg);
                  while ( (bytesRead = inFileStream.read(Buffer)) != -1)
                  {
                     outFileStream.write(Buffer, 0, bytesRead);
                  }
                  inFileStream.close();
                  outFileStream.close();
               } catch (java.io.IOException ioe)
               {
                  String Msg = "File Import Failure - IO Error \n";
                  Msg += ioe.toString();
                  s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | s2iError.LOG | s2iError.DISPLAY, this);
                  return; // This will make the user stay on the Project setup form
               }
               

               //Create the input and the destination file
               s2iSpiceReader SpiceReader;
               BufferedWriter outBuf;
               try{
                  SpiceReader = new s2iSpiceReader(tmpFile.toString());
                  outBuf = new BufferedWriter(new FileWriter (outFileNameWPath));
               } catch (java.io.IOException ioe)
               {
                  String Msg = "File Import Failure. Error in creating \n";
                  Msg += outFileNameWPath;
                  s2iError.PrintMsg(ioe.toString(), s2iError.ERR, s2iError.LOG | s2iError.DISPLAY, this);
                  s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | s2iError.LOG | s2iError.DISPLAY, this);
                  return; // This will make the user stay on the Project setup form
               }
               //Now copy from temporary file to destination
               try {
                  StringBuffer SpiceLine = new StringBuffer();
                  Vector allLines = new Vector();
                  String Msg ="Copy " + fileName + " from " + tmpFile.toString() + " to " + s2iGlobals.ProjDirFile;
                  s2iError.Debug(Msg);

                  while(SpiceReader.getSpiceLine(SpiceLine, allLines) != 0)
                  {
                     /*****************************************************
                      * All statements starting with "." barring .INCLUDE,
                      * .GLOBAL, .MODEL, .SUBCKT and .ENDS will be comment-
                      * ed out
                      ****************************************************/
                     if (SpiceLine.toString().trim().startsWith(".") &&
                         !SpiceLine.toString().trim().toUpperCase().startsWith(s2iGlobals.KWS_INCLUDE) &&
                         !SpiceLine.toString().trim().toUpperCase().startsWith(s2iGlobals.KWS_GLOBAL) &&
                         !SpiceLine.toString().trim().toUpperCase().startsWith(s2iGlobals.KWS_MODEL) &&
                         !SpiceLine.toString().trim().toUpperCase().startsWith(s2iGlobals.KWS_SUBCKT) &&
                         !SpiceLine.toString().trim().toUpperCase().startsWith(s2iGlobals.KWS_SUBCKT_END))
                     {
                        //write allLines
                       int size = allLines.size();
                       for (int i=0; i< size; i++)
                       {
                          outBuf.write(s2iGlobals.ST_COMMENT + " " + 
                                       ((StringBuffer) allLines.elementAt(i)).toString());
                          outBuf.newLine();
                       }
                     }
                     else
                     {
                       //write * + allLines
                       int size = allLines.size();
                       for (int i=0; i< size; i++)
                       {
                          outBuf.write( ((StringBuffer) allLines.elementAt(i)).toString());
                          outBuf.newLine();
                       }
                     }
                  }

                  // Also add include statement for the Ckt instantiation 
                  // and source element files which are generated on 
                  // Translate->Execute
                  //outBuf.write(".INCLUDE circuit_" + fileName);
                  //outBuf.newLine();
                  // No longer required. Typ/Min/Max node files will be 
                  // written in the s2i file.
                  //outBuf.write(".INCLUDE node_typ_" + fileName);
                  //outBuf.newLine();
                  tmpFile.delete();
                  SpiceReader.close();
                  outBuf.close();
               } catch (java.io.IOException ioe)
               {
                  String Msg = "File Import Failure - IO Error \n";
                  Msg += ioe.toString();
                  s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | s2iError.LOG | s2iError.DISPLAY, this);
                  return; // This will make the user stay on the Project setup form
               }
           } //if (newProject) then the file got copied

            /*******************************************************
             * The SPICE File which now exists in the project      *
             * directory will be parsed to check for any Analysis  *
             * statement, and recursive existence of all Includes  *
             *******************************************************/
            // Keep auditing till it returns false i.e.. redo == false
            String Command = "";
            try {Command = audit(outFileNameWPath);}
            catch (java.io.FileNotFoundException ex)
            {
               String Msg = " File Not Found while auditing:" + ex.getMessage();
               s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | 
                                   s2iError.LOG | s2iError.DISPLAY, this);
            }
            catch (java.io.IOException ioe)
            {
               String Msg = "I/O Error while auditing";
               s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | 
                                   s2iError.LOG | s2iError.DISPLAY, this);
            }
            
            if (Command.equals("CANCEL"))
            {
               return; // If it's cancel STOP
            }

            /*******************************************************
             * It's time to prepare Files for typ/min/max Library  *
             * references. Their names to be picked from  SpiTran  *
             * globals. These files are to have:                   *
             *   1. include statements for Ckt instantiation and   *
             *      source element files which are generated on    *
             *      Translate->Execute                             *
             *   2. Write in the LIBS/INCLUDES statements. If not- *
             *      thing in Best/Worst, simply copy the Typ data. *
             *******************************************************/
             boolean empty = false;
             if (BestModelTreeList.isEmpty())
             {
                 empty = true;
             }
             if (WorstModelTreeList.isEmpty())
             {
                 empty = true;
             }
             
             if (empty)
             {
                 String Msg = "Typcal values used for empty Best/Worst Models";
                 s2iError.PrintMsg(Msg, s2iError.WARN, s2iError.POPUP | 
                                     s2iError.LOG, this);
             }
            
                 
            /*********************************************************
             * Save the SPICE filename, the Lib names, and the Model *
             * names that will finally be part of the SpiTran DB.    *
             *********************************************************/
             s2iGlobals.spiceFileName = fileName;

            /*********************************************************
             * Saving the Buffer Technology                          *
             *********************************************************/
             s2iGlobals.gBufTech = (String) jComboBox1.getSelectedItem();

            /*********************************************************
             * Archiving the Typ/Best/Worst Libraries being displayed*
             * and models that have been included                    *
             *********************************************************/
             s2iGlobals.gTypLibTreeList = (Vector) TypLibTreeList.archive();
             s2iGlobals.gBestLibTreeList = (Vector) BestLibTreeList.archive();
             s2iGlobals.gWorstLibTreeList = (Vector) WorstLibTreeList.archive();
             s2iGlobals.gTypModelTreeList = (Vector) TypModelTreeList.archive();
             s2iGlobals.gBestModelTreeList = (Vector) BestModelTreeList.archive();
             s2iGlobals.gWorstModelTreeList = (Vector) WorstModelTreeList.archive();

             /*********************************************************
              * If the project is new then list the available subCkts *
              * in the SPICE File.
              ********************************************************/
              
             if (newProject)
             {
                ((s2iMain) parent).readSubCkts();
             }
            
           // Create a Window closing event and dispatch it to this.
           java.awt.AWTEvent  e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
           dispatchEvent(e);
	}

	void jCancelButton_actionPerformed(java.awt.event.ActionEvent event)
	{
           // to do: code goes here.
           /* Cancel this form */
           // Create a Window closing event and dispatch it to this.
           java.awt.AWTEvent  e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
           dispatchEvent(e);
	}


	/********************************************************************
	 * This function gets called whenever the DB is opened (File->Open) *
         ********************************************************************/
	public void getDB()
	{
            /*********************************************************
             * Load the Buffer Technology                            *
             *********************************************************/
	    if (s2iGlobals.gBufTech != null)
		jComboBox1.setSelectedItem(s2iGlobals.gBufTech);

            /*********************************************************
             * Load the Typ/Best/Worst Libraries and models that     *
             * have been included                                    *
             *********************************************************/
             Enumeration elemList;

	     try
             {
	        elemList = s2iGlobals.gTypLibTreeList.elements();
	        while (elemList.hasMoreElements())
	        {
	            String elem = (String) elemList.nextElement();
		    TypLibTreeList.addElem(elem);
	        }

	        elemList = s2iGlobals.gBestLibTreeList.elements();
	        while (elemList.hasMoreElements())
	        {
	            String elem = (String) elemList.nextElement();
		    BestLibTreeList.addElem(elem);
	        }

	        elemList = s2iGlobals.gWorstLibTreeList.elements();
	        while (elemList.hasMoreElements())
	        {
	            String elem = (String) elemList.nextElement();
		    WorstLibTreeList.addElem(elem);
	        }

	        elemList = s2iGlobals.gTypModelTreeList.elements();
	        while (elemList.hasMoreElements())
	        {
	            String elem = (String) elemList.nextElement();
		    TypModelTreeList.addElem(elem);
	        }

	        elemList = s2iGlobals.gBestModelTreeList.elements();
	        while (elemList.hasMoreElements())
	        {
	            String elem = (String) elemList.nextElement();
		    BestModelTreeList.addElem(elem);
	        }

	        elemList = s2iGlobals.gWorstModelTreeList.elements();
	        while (elemList.hasMoreElements())
	        {
	            String elem = (String) elemList.nextElement();
		    WorstModelTreeList.addElem(elem);
	        }
             }
	     catch (java.io.FileNotFoundException FilNotFnd)
    	     {
		String Msg = new String("SPICE Library \"" + FilNotFnd.getMessage() +
		                        "\" does not exist");
		s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP |
                           s2iError.LOG | s2iError.DISPLAY, this);
	     }
	     catch (java.io.IOException IOerr)
 	     {
	        String Msg = new String("IO error in \"" + IOerr.getMessage()
		                         + "\"");
		s2iError.PrintMsg(Msg, s2iError.ERR, s2iError.POPUP | 
		                 s2iError.LOG | s2iError.DISPLAY, this);
	     }


	}


	void s2iProjectSetup_windowClosed(java.awt.event.WindowEvent event)
	{
		// to do: code goes here.
	}
}
