/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */


/*
		A basic implementation of the JDialog class.
*/

import javax.swing.*;
import java.awt.*;
import javax.swing.JDialog;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JButton;
public class s2iQuitDialog extends javax.swing.JDialog
{
	public s2iQuitDialog(Frame parent, boolean modal)
	{
	    super(parent, modal);
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		getContentPane().setLayout(new BorderLayout(20,0));
		setVisible(false);
		setSize(234,108);
		jQuitLabel = new javax.swing.JLabel();
		jQuitLabel.setText("Quit SpiTran ?");
		jQuitLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		jQuitLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
		jQuitLabel.setBounds(0,0,234,73);
		jQuitLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jQuitLabel.setForeground(new Color(0));
		jQuitLabel.setBackground(new Color(-3355444));
		getContentPane().add("Center", jQuitLabel);
		jPanel1 = new javax.swing.JPanel();
		jPanel1.setLayout(new FlowLayout(FlowLayout.CENTER,20,5));
		jPanel1.setBounds(0,73,234,35);
		jPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.setForeground(new Color(0));
		getContentPane().add("South", jPanel1);
		jYes = new javax.swing.JButton();
		jYes.setText("Yes");
		jYes.setBounds(53,5,55,25);
		jYes.setFont(new Font("Dialog", Font.PLAIN, 12));
		jYes.setForeground(new Color(0));
		jPanel1.add(jYes);
		jNoButton = new javax.swing.JButton();
		jNoButton.setText("No ");
		jNoButton.setBounds(128,5,53,25);
		jNoButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNoButton.setForeground(new Color(0));
		jPanel1.add(jNoButton);
		//}}
		
		//{{Non-symantec Init 
		// How about a nice beep
		toolkit = Toolkit.getDefaultToolkit();
		toolkit.beep();
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		jYes.addActionListener(lSymAction);
		jNoButton.addActionListener(lSymAction);
		//}}
	}

	public s2iQuitDialog(String sTitle)
	{
		this();
		setTitle(sTitle);
	}
	
	public s2iQuitDialog()
	{
	    this(null, false);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new s2iQuitDialog()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JLabel jQuitLabel;
	javax.swing.JPanel jPanel1;
	javax.swing.JButton jYes;
	javax.swing.JButton jNoButton;
	//}}
	
	//{{Non-symantec controls
	private Toolkit toolkit;
	//}} 

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iQuitDialog.this)
				JDialog1_WindowClosing(event);
		}
	}

	void JDialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		// System.exit(0);    // close the application
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jYes)
				jYes_actionPerformed(event);
			else if (object == jNoButton)
				jNoButton_actionPerformed(event);
		}
	}

	void jYes_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		java.awt.AWTEvent e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
		dispatchEvent(e);
		System.exit(0);
	}

	void jNoButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		java.awt.AWTEvent e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
		dispatchEvent(e);
	}
}
