/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */


/*
		A basic implementation of the JDialog class.
*/

import javax.swing.*;
import java.awt.*;
import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JTextPane;
import javax.swing.JTextArea;
import java.io.BufferedWriter;
import java.io.FileWriter;

public class s2iRunStatus extends javax.swing.JDialog
{
	public s2iRunStatus()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Execution Messages");
		getContentPane().setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(600,400);
		jScrollPane1 = new javax.swing.JScrollPane();
		jScrollPane1.setBounds(0,0,444,276);
		jScrollPane1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jScrollPane1.setForeground(new Color(0));
		jScrollPane1.setBackground(new Color(-3355444));
		getContentPane().add("Center", jScrollPane1);
		jTextArea1 = new javax.swing.JTextArea();
		jTextArea1.setBounds(0,0,20,40);
		jTextArea1.setFont(new Font("Monospaced", Font.PLAIN, 12));
		jTextArea1.setForeground(new Color(0));
		jTextArea1.setBackground(new Color(16777215));
		jScrollPane1.getViewport().add(jTextArea1);
		jSouthPanel = new javax.swing.JPanel();
		jSouthPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jSouthPanel.setBounds(0,276,444,35);
		jSouthPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jSouthPanel.setForeground(new Color(0));
		getContentPane().add("South", jSouthPanel);
		jClose = new javax.swing.JButton();
		jClose.setText("Close");
		jClose.setBounds(114,5,67,25);
		jClose.setFont(new Font("Dialog", Font.PLAIN, 12));
		jClose.setForeground(new Color(0));
		jClose.setBackground(new Color(-3355444));
		jSouthPanel.add(jClose);
		jSaveAs = new javax.swing.JButton();
		jSaveAs.setText("Save...");
		jSaveAs.setBounds(186,5,71,25);
		jSaveAs.setFont(new Font("Dialog", Font.PLAIN, 12));
		jSaveAs.setForeground(new Color(0));
		jSaveAs.setBackground(new Color(-3355444));
		jSouthPanel.add(jSaveAs);
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		jClose.addActionListener(lSymAction);
		jSaveAs.addActionListener(lSymAction);
		//}}
	}

	public s2iRunStatus(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

	public void setVisible(boolean b)
	{
		if (b)
			setLocation(50, 50);
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new s2iRunStatus()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	javax.swing.JScrollPane jScrollPane1;
	javax.swing.JTextArea jTextArea1;
	javax.swing.JPanel jSouthPanel;
	javax.swing.JButton jClose;
	javax.swing.JButton jSaveAs;
	//}}

    public JTextArea getTextArea()
    {
        return(jTextArea1);
    }
    
	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iRunStatus.this)
				JDialog1_WindowClosing(event);
		}
	}

	void JDialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		//System.exit(0);    // close the application
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jClose)
				jClose_actionPerformed(event);
			else if (object == jSaveAs)
				jSaveAs_actionPerformed(event);
		}
	}

	void jClose_actionPerformed(java.awt.event.ActionEvent event)
	{
		/* Cancel this form */
		java.awt.AWTEvent e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
		dispatchEvent(e);
	}

	void jSaveAs_actionPerformed(java.awt.event.ActionEvent event)
	{
	   JFileChooser saveBrowser = new JFileChooser();
       if(s2iGlobals.ProjDirFile != null)
         saveBrowser.setCurrentDirectory(new java.io.File(s2iGlobals.ProjDirFile.getPath()));
       saveBrowser.setSelectedFile(new java.io.File(s2iGlobals.RUN_SAVE_FILE));
   	   saveBrowser.setApproveButtonText(" Save ");
	   saveBrowser.setDialogTitle("Save s2ibis2 Execution Messages");
	   int retVal = saveBrowser.showOpenDialog(this);
	   if (retVal == JFileChooser.APPROVE_OPTION)
	   {
	      java.io.File file = saveBrowser.getSelectedFile();
	      try
          {
            // The text is saved with newlines only.
            // It would be nice if it also had carriage returns on Windows.
            FileWriter saveWriter = new java.io.FileWriter(file);
            saveWriter.write(jTextArea1.getText());
            saveWriter.close();
            String msg = "Execution messages saved in " + file.getPath();
            s2iError.PrintMsg(msg, s2iError.INFO,
              s2iError.DISPLAY | s2iError.LOG, null);
          }
          catch(Exception e)
          {
            s2iError.PrintMsg(e.getLocalizedMessage(), s2iError.ERR,
              s2iError.DISPLAY | s2iError.LOG | s2iError.POPUP, null);
          }
       }
	}

	void addText(String str)
	{
	    jTextArea1.append(str);
	}

	void clearText()
	   throws java.lang.IllegalArgumentException,
	          javax.swing.text.BadLocationException
	{
	    int lines = jTextArea1.getLineCount();
	    for (int i=0; i <= lines; i++)
	    {
	       int end = jTextArea1.getLineEndOffset(i);
	       jTextArea1.replaceRange("", 0, end);
	    }
	}
}
	
