/*
 *
 * Copyright 1999, Cadence Design Systems, Incorporated.
 *
 * Cadence Design Systems (Cadence) and the author hereby disclaim
 * all implied warranties, including the implied warranties of merchant-
 * ability and fitness for a particular purpose. Cadence is not liable for
 * any damages incurred by the use of this software and/or documentation,
 * including direct, indirect, special, incidental, or consequential
 * damages.
 *
 * Cadence grants the bearer the right to modify, copy, and redistribute
 * this software and documentation, but requests that Cadence be acknowledged
 * for its contribution in the resulting product.
 *
 */


/*
		A basic implementation of the JDialog class.
*/

import javax.swing.*;
import java.awt.*;
import javax.swing.JDialog;

import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTree;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextPane;
import javax.swing.JTextArea;
import javax.swing.tree.*;
import java.util.Date;
import java.text.DateFormat;
public class s2iTransOptions extends javax.swing.JDialog
{
	public s2iTransOptions()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setTitle("Translation Command Settings");
		getContentPane().setLayout(new BorderLayout(5,0));
		setVisible(false);

		jNorthPanel = new javax.swing.JPanel();
		jNorthPanel.setAlignmentX(0.0F);
		jNorthPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jNorthPanel.setSize(new Dimension(600,40));
		jNorthPanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jImportButton = new javax.swing.JButton();
		jImportButton.setText("Import Settings from File...");
		jImportButton.setActionCommand("Import");
		jImportButton.setAlignmentX(0.5F);
		jImportButton.setBounds(114,40,69,25);
		jImportButton.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNorthPanel.add(jImportButton);

		jBufTypeLabel = new javax.swing.JLabel();
		jBufTypeLabel.setText("Buffer type  ");
		jBufTypeLabel.setBounds(0,5,63,15);
		jBufTypeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNorthPanel.add(jBufTypeLabel);

		jBufTypeCB = new javax.swing.JComboBox();
		jBufTypeCB.setBounds(63,0,124,24);
		jBufTypeCB.setFont(new Font("Dialog", Font.BOLD, 12));
		jNorthPanel.add(jBufTypeCB);

		getContentPane().add("North", jNorthPanel);

		jSouthPanel = new javax.swing.JPanel();
		jSouthPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jSouthPanel.setPreferredSize(new Dimension(590,35));

		jOK = new javax.swing.JButton();
		jOK.setText("  OK  ");
		jOK.setActionCommand("  OK  ");
		jOK.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
		jOK.setBounds(191,5,63,25);
		jOK.setFont(new Font("Dialog", Font.PLAIN, 12));
		jSouthPanel.add(jOK);

		jCancel = new javax.swing.JButton();
		jCancel.setText("Cancel");
		jCancel.setActionCommand("Cancel");
		jCancel.setBounds(259,5,73,25);
		jCancel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jSouthPanel.add(jCancel);

		jHelp = new javax.swing.JButton();
		jHelp.setText("Help");
		jHelp.setActionCommand("Help");
		jHelp.setBounds(337,5,61,25);
		jHelp.setFont(new Font("Dialog", Font.PLAIN, 12));
		jSouthPanel.add(jHelp);

		getContentPane().add("South", jSouthPanel);

        // The center panel uses no layout manager
		jCenterPanel = new javax.swing.JTabbedPane(JTabbedPane.TOP);
		jCenterPanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jModePanel = new javax.swing.JPanel();
		jModePanel.setLayout(new GridLayout(10,1,5,5));
		jModePanel.setBounds(0,0,398,294);
		jModePanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jNorthModePanel = new javax.swing.JPanel();
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		jNorthModePanel.setLayout(gridBagLayout);
		jNorthModePanel.setBounds(0,0,398,24);
		jNorthModePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModePanel.add(jNorthModePanel);

		jSpiceTypeLabel = new javax.swing.JLabel();
		jSpiceTypeLabel.setText("SPICE Type    ");
		jSpiceTypeLabel.setBounds(0,6,77,15);
		jSpiceTypeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(4,0,0,0);
		((GridBagLayout)jNorthModePanel.getLayout()).setConstraints(jSpiceTypeLabel, gbc);
		jNorthModePanel.add(jSpiceTypeLabel);

		jSpiceTypeTF = new javax.swing.JTextField();
		jSpiceTypeTF.setMargin(new java.awt.Insets(0,0,0,0));
		jSpiceTypeTF.setBounds(77,2,84,19);
		jSpiceTypeTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.anchor = GridBagConstraints.WEST;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(2,0,3,0);
		gbc.ipadx = 80;
		((GridBagLayout)jNorthModePanel.getLayout()).setConstraints(jSpiceTypeTF, gbc);
		jNorthModePanel.add(jSpiceTypeTF);

		jIterateCheckBox = new javax.swing.JCheckBox();
		jIterateCheckBox.setText("Iterate            (Create missing SPICE files)");
		jIterateCheckBox.setActionCommand("Iterate            (Create missing SPICE files)");
		jIterateCheckBox.setBounds(0,29,398,24);
		jIterateCheckBox.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModePanel.add(jIterateCheckBox);

		jCleanupCheckBox = new javax.swing.JCheckBox();
		jCleanupCheckBox.setText("Cleanup        (Clean up the intermediate files)");
		jCleanupCheckBox.setActionCommand("Cleanup        (Clean up the intermediate files)");
		jCleanupCheckBox.setBounds(0,58,398,24);
		jCleanupCheckBox.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModePanel.add(jCleanupCheckBox);

		jSummaryCheckBox = new javax.swing.JCheckBox();
		jSummaryCheckBox.setText("Summarize   (Produce report in summarized form)");
		jSummaryCheckBox.setActionCommand("Summarize   (Produce report in summarized form)");
		jSummaryCheckBox.setBounds(0,87,398,24);
		jSummaryCheckBox.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModePanel.add(jSummaryCheckBox);
        
		jVOpPanel = new javax.swing.JPanel();
		jVOpPanel.setAlignmentX(0.279703F);
		jVOpPanel.setLayout(new BoxLayout(jVOpPanel,BoxLayout.Y_AXIS));
		jVOpPanel.setVisible(false);
		jVOpPanel.setBounds(0,0,398,294);
		jVOpPanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jLabel1 = new javax.swing.JLabel();
		jLabel1.setRequestFocusEnabled(false);
		jLabel1.setText("Fill in either the Voltage range or the Reference levels");
		jLabel1.setBounds(0,0,291,15);
		jLabel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jVOpPanel.add(jLabel1);

		jRangePanel = new javax.swing.JPanel();
		jRangePanel.setAlignmentX(0.0F);
		jRangePanel.setLayout(new GridLayout(2,4,0,0));
		jRangePanel.setBounds(0,15,398,38);
		jRangePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jVOpPanel.add(jRangePanel);

		jBlankLabel = new javax.swing.JLabel();
		jBlankLabel.setBounds(0,0,99,19);
		jBlankLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		jRangePanel.add(jBlankLabel);

		jTypLabel = new javax.swing.JLabel();
		jTypLabel.setRequestFocusEnabled(false);
		jTypLabel.setText("Typical");
		jTypLabel.setToolTipText("          ");
		jTypLabel.setBounds(99,0,99,19);
		jTypLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRangePanel.add(jTypLabel);

		jMinLabel = new javax.swing.JLabel();
		jMinLabel.setText("Minimum");
		jMinLabel.setBounds(198,0,99,19);
		jMinLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRangePanel.add(jMinLabel);

		jMaxLabel = new javax.swing.JLabel();
		jMaxLabel.setText("Maximum");
		jMaxLabel.setBounds(297,0,99,19);
		jMaxLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRangePanel.add(jMaxLabel);
        
		jVRLabel = new javax.swing.JLabel();
		jVRLabel.setText("Voltage Range");
		jVRLabel.setBounds(0,19,99,19);
		jVRLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRangePanel.add(jVRLabel);

		jVRTypTextField = new javax.swing.JTextField();
		jVRTypTextField.setMargin(new java.awt.Insets(0,0,0,0));
		jVRTypTextField.setBounds(99,19,99,19);
		jVRTypTextField.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRangePanel.add(jVRTypTextField);
        
		jVRMinTextField = new javax.swing.JTextField();
		jVRMinTextField.setMargin(new java.awt.Insets(0,0,0,0));
		jVRMinTextField.setBounds(198,19,99,19);
		jVRMinTextField.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRangePanel.add(jVRMinTextField);
        
		jVRMaxTextField = new javax.swing.JTextField();
		jVRMaxTextField.setMargin(new java.awt.Insets(0,0,0,0));
		jVRMaxTextField.setBounds(297,19,99,19);
		jVRMaxTextField.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRangePanel.add(jVRMaxTextField);
        
		jRefPanel = new javax.swing.JPanel();
		jRefPanel.setAlignmentX(0.0F);
		jRefPanel.setLayout(new GridLayout(5,4,0,0));
		jRefPanel.setBounds(0,53,398,95);
		jRefPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jVOpPanel.add(jRefPanel);
        
		jLabel5 = new javax.swing.JLabel();
		jLabel5.setBounds(0,0,99,19);
		jLabel5.setFont(new Font("Dialog", Font.BOLD, 12));
		jRefPanel.add(jLabel5);
        
		jLabel2 = new javax.swing.JLabel();
		jLabel2.setText("Typical");
		jLabel2.setBounds(99,0,99,19);
		jLabel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jLabel2);
        
		jLabel3 = new javax.swing.JLabel();
		jLabel3.setText("Minimum");
		jLabel3.setBounds(198,0,99,19);
		jLabel3.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jLabel3);
        
		jLabel4 = new javax.swing.JLabel();
		jLabel4.setText("Maximum");
		jLabel4.setBounds(297,0,99,19);
		jLabel4.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jLabel4);
        
		jLabel6 = new javax.swing.JLabel();
		jLabel6.setText("Pull up");
		jLabel6.setBounds(0,19,99,19);
		jLabel6.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jLabel6);
        
		jPullupVtypTF = new javax.swing.JTextField();
		jPullupVtypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPullupVtypTF.setBounds(99,19,99,19);
		jPullupVtypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPullupVtypTF);
        
		jPullupVminTF = new javax.swing.JTextField();
		jPullupVminTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPullupVminTF.setBounds(198,19,99,19);
		jPullupVminTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPullupVminTF);
        
		jPullupVmaxTF = new javax.swing.JTextField();
		jPullupVmaxTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPullupVmaxTF.setBounds(297,19,99,19);
		jPullupVmaxTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPullupVmaxTF);
        
		jLabel7 = new javax.swing.JLabel();
		jLabel7.setText("Pull down");
		jLabel7.setBounds(0,38,99,19);
		jLabel7.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jLabel7);
        
		jPulldnVtypTF = new javax.swing.JTextField();
		jPulldnVtypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPulldnVtypTF.setBounds(99,38,99,19);
		jPulldnVtypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPulldnVtypTF);
        
		jPulldnVminTF = new javax.swing.JTextField();
		jPulldnVminTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPulldnVminTF.setBounds(198,38,99,19);
		jPulldnVminTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPulldnVminTF);
        
		jPulldnVmaxTF = new javax.swing.JTextField();
		jPulldnVmaxTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPulldnVmaxTF.setBounds(297,38,99,19);
		jPulldnVmaxTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPulldnVmaxTF);
        
		jLabel8 = new javax.swing.JLabel();
		jLabel8.setText("Power clamp");
		jLabel8.setBounds(0,57,99,19);
		jLabel8.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jLabel8);
        
		jPclampVtypTF = new javax.swing.JTextField();
		jPclampVtypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPclampVtypTF.setBounds(99,57,99,19);
		jPclampVtypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPclampVtypTF);
        
		jPclampVminTF = new javax.swing.JTextField();
		jPclampVminTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPclampVminTF.setBounds(198,57,99,19);
		jPclampVminTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPclampVminTF);
        
		jPclampVmaxTF = new javax.swing.JTextField();
		jPclampVmaxTF.setMargin(new java.awt.Insets(0,0,0,0));
		jPclampVmaxTF.setBounds(297,57,99,19);
		jPclampVmaxTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jPclampVmaxTF);
        
		jGClampLabel = new javax.swing.JLabel();
		jGClampLabel.setText("Ground Clamp");
		jGClampLabel.setBounds(0,76,99,19);
		jGClampLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRefPanel.add(jGClampLabel);
        
		jGclampVtypTF = new javax.swing.JTextField();
		jGclampVtypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jGclampVtypTF.setBounds(99,76,99,19);
		jGclampVtypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jGclampVtypTF);
        
		jGclampVminTF = new javax.swing.JTextField();
		jGclampVminTF.setMargin(new java.awt.Insets(0,0,0,0));
		jGclampVminTF.setBounds(198,76,99,19);
		jGclampVminTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jGclampVminTF);
        
		jGclampVmaxTF = new javax.swing.JTextField();
		jGclampVmaxTF.setMargin(new java.awt.Insets(0,0,0,0));
		jGclampVmaxTF.setBounds(297,76,99,19);
		jGclampVmaxTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRefPanel.add(jGclampVmaxTF);
        
		jPanel3 = new javax.swing.JPanel();
		jPanel3.setAlignmentX(0.0F);
		gridBagLayout = new GridBagLayout();
		jPanel3.setLayout(gridBagLayout);
		jPanel3.setBounds(0,148,398,146);
		jPanel3.setFont(new Font("Dialog", Font.PLAIN, 12));
		jVOpPanel.add(jPanel3);
        
		jTOpPanel = new javax.swing.JPanel();
		jTOpPanel.setLayout(new BorderLayout(0,10));
		jTOpPanel.setVisible(false);
		jTOpPanel.setBounds(0,0,398,294);
		jTOpPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
        
		jTRangePanel = new javax.swing.JPanel();
		jTRangePanel.setLayout(new BorderLayout(0,0));
		jTRangePanel.setBounds(0,0,398,38);
		jTRangePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTOpPanel.add("North", jTRangePanel);
        
		jPanel2 = new javax.swing.JPanel();
		jPanel2.setLayout(new GridLayout(1,1,0,0));
		jPanel2.setBounds(0,0,111,38);
		jPanel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTRangePanel.add("West", jPanel2);
        
		jTRangeLabel = new javax.swing.JLabel();
		jTRangeLabel.setVerticalAlignment(javax.swing.SwingConstants.BOTTOM);
		jTRangeLabel.setText("Temperature Range");
		jTRangeLabel.setBounds(0,0,111,38);
		jTRangeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel2.add(jTRangeLabel);
        
		jTBWPanel = new javax.swing.JPanel();
		jTBWPanel.setLayout(new GridLayout(2,3,0,0));
		jTBWPanel.setBounds(111,0,287,38);
		jTBWPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTRangePanel.add("Center", jTBWPanel);
        
		jTypLabel1 = new javax.swing.JLabel();
		jTypLabel1.setText("Typical");
		jTypLabel1.setBounds(0,0,95,19);
		jTypLabel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTBWPanel.add(jTypLabel1);
        
		jBestLabel = new javax.swing.JLabel();
		jBestLabel.setText("Best");
		jBestLabel.setBounds(95,0,95,19);
		jBestLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTBWPanel.add(jBestLabel);
        
		jWorstLabel = new javax.swing.JLabel();
		jWorstLabel.setText("Worst");
		jWorstLabel.setBounds(190,0,95,19);
		jWorstLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTBWPanel.add(jWorstLabel);
        
		jTempTtypTF = new javax.swing.JTextField();
		jTempTtypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jTempTtypTF.setBounds(0,19,95,19);
		jTempTtypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jTBWPanel.add(jTempTtypTF);
        
		jTempTminTF = new javax.swing.JTextField();
		jTempTminTF.setMargin(new java.awt.Insets(0,0,0,0));
		jTempTminTF.setBounds(95,19,95,19);
		jTempTminTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jTBWPanel.add(jTempTminTF);
        
		jTempTmaxTF = new javax.swing.JTextField();
		jTempTmaxTF.setMargin(new java.awt.Insets(0,0,0,0));
		jTempTmaxTF.setBounds(190,19,95,19);
		jTempTmaxTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jTBWPanel.add(jTempTmaxTF);
        
		jNotePanel = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		jNotePanel.setLayout(gridBagLayout);
		jNotePanel.setBounds(0,48,398,246);
		jNotePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jTOpPanel.add("Center", jNotePanel);
        
		jTextPane1 = new javax.swing.JTextPane();
		jTextPane1.setText("Note: For CMOS buffers, Best corresponds to Max temperature and worst corresponds to Min.");
		jTextPane1.setMargin(new java.awt.Insets(3,3,3,3));
		jTextPane1.setEditable(false);
		jTextPane1.setBounds(0,0,398,246);
		jTextPane1.setFont(new Font("Serif", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jNotePanel.getLayout()).setConstraints(jTextPane1, gbc);
		jNotePanel.add(jTextPane1);
        
		jStimulusPanel = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		jStimulusPanel.setLayout(gridBagLayout);
		jStimulusPanel.setVisible(false);
		jStimulusPanel.setBounds(0,0,398,294);
		jStimulusPanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jPanel5 = new javax.swing.JPanel();
		jPanel5.setLayout(new BorderLayout(20,0));
		jPanel5.setBounds(0,10,398,19);
		jPanel5.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.weighty = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jStimulusPanel.getLayout()).setConstraints(jPanel5, gbc);
		jStimulusPanel.add(jPanel5);
        
		jSimTimeLabel = new javax.swing.JLabel();
		jSimTimeLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
		jSimTimeLabel.setText("Simulation Time for One Cycle [Sim Time]");
		jSimTimeLabel.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
		jSimTimeLabel.setBounds(0,0,228,19);
		jSimTimeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel5.add("West", jSimTimeLabel);
        
		jSimTimeTF = new javax.swing.JTextField();
		jSimTimeTF.setMargin(new java.awt.Insets(0,0,0,0));
		jSimTimeTF.setBounds(248,0,150,19);
		jSimTimeTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jPanel5.add("Center", jSimTimeTF);
        
		jPanel1 = new javax.swing.JPanel();
		jPanel1.setLayout(new GridLayout(2,2,50,15));
		jPanel1.setBounds(0,40,398,53);
		jPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 0.1;
		gbc.weighty = 0.1;
		gbc.anchor = GridBagConstraints.NORTH;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jStimulusPanel.getLayout()).setConstraints(jPanel1, gbc);
		jStimulusPanel.add(jPanel1);
        
		jStim11Panel = new javax.swing.JPanel();
		jStim11Panel.setLayout(new BorderLayout(10,0));
		jStim11Panel.setBounds(0,0,174,19);
		jStim11Panel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.add(jStim11Panel);
        
		jRiseTimeLabel = new javax.swing.JLabel();
		jRiseTimeLabel.setText("Rise Time [Tr]");
		jRiseTimeLabel.setBounds(0,0,77,19);
		jRiseTimeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jStim11Panel.add("West", jRiseTimeLabel);
        
		jRiseTimeTF = new javax.swing.JTextField();
		jRiseTimeTF.setMargin(new java.awt.Insets(0,0,0,0));
		jRiseTimeTF.setBounds(87,0,87,19);
		jRiseTimeTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jStim11Panel.add("Center", jRiseTimeTF);
        
		jStim12Panel = new javax.swing.JPanel();
		jStim12Panel.setLayout(new BorderLayout(10,0));
		jStim12Panel.setBounds(224,0,174,19);
		jStim12Panel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.add(jStim12Panel);
        
		jFallTimeLabel = new javax.swing.JLabel();
		jFallTimeLabel.setText("FallTime [Tf]");
		jFallTimeLabel.setBounds(0,0,67,19);
		jFallTimeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jStim12Panel.add("West", jFallTimeLabel);
        
		jFallTimeTF = new javax.swing.JTextField();
		jFallTimeTF.setMargin(new java.awt.Insets(0,0,0,0));
		jFallTimeTF.setBounds(77,0,97,19);
		jFallTimeTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jStim12Panel.add("Center", jFallTimeTF);
        
		jStim21Panel = new javax.swing.JPanel();
		jStim21Panel.setLayout(new BorderLayout(32,0));
		jStim21Panel.setBounds(0,34,174,19);
		jStim21Panel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.add(jStim21Panel);
        
		jLowVLabel = new javax.swing.JLabel();
		jLowVLabel.setText("Low V [Vil]");
		jLowVLabel.setBounds(0,0,55,19);
		jLowVLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jStim21Panel.add("West", jLowVLabel);
        
		jVilTF = new javax.swing.JTextField();
		jVilTF.setMargin(new java.awt.Insets(0,0,0,0));
		jVilTF.setBounds(87,0,87,19);
		jVilTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jStim21Panel.add("Center", jVilTF);
        
		jStim22Panel = new javax.swing.JPanel();
		jStim22Panel.setLayout(new BorderLayout(15,0));
		jStim22Panel.setBounds(224,34,174,19);
		jStim22Panel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPanel1.add(jStim22Panel);
        
		jHighVLabel = new javax.swing.JLabel();
		jHighVLabel.setText("High V [Vih]");
		jHighVLabel.setBounds(0,0,62,19);
		jHighVLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jStim22Panel.add("West", jHighVLabel);
        
		jVihTF = new javax.swing.JTextField();
		jVihTF.setMargin(new java.awt.Insets(0,0,0,0));
		jVihTF.setBounds(77,0,97,19);
		jVihTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jStim22Panel.add("Center", jVihTF);
        
		jPanel6 = new javax.swing.JPanel();
		jPanel6.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jPanel6.setBounds(0,114,398,179);
		jPanel6.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.weightx = 0.1;
		gbc.weighty = 0.8;
		gbc.anchor = GridBagConstraints.SOUTH;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jStimulusPanel.getLayout()).setConstraints(jPanel6, gbc);
		jStimulusPanel.add(jPanel6);
        
		jNodePanel = new javax.swing.JPanel();
		jNodePanel.setLayout(new GridLayout(1,1,10,0));
		jNodePanel.setVisible(false);
		jNodePanel.setBounds(0,0,398,294);
		jNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jLeftNodePanel = new javax.swing.JPanel();
		jLeftNodePanel.setLayout(new GridLayout(10,1,0,10));
		jLeftNodePanel.setBounds(0,0,194,294);
		jLeftNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNodePanel.add(jLeftNodePanel);

		jIbisNmPanel = new javax.swing.JPanel();
		jIbisNmPanel.setLayout(new BorderLayout(10,0));
		jIbisNmPanel.setBounds(0,0,194,20);
		jIbisNmPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLeftNodePanel.add(jIbisNmPanel);

		jIbisNmLabel = new javax.swing.JLabel();
		jIbisNmLabel.setText("IBIS Model Name");
		jIbisNmLabel.setBounds(0,0,95,20);
		jIbisNmLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jIbisNmPanel.add("West", jIbisNmLabel);

		jIbisTF = new javax.swing.JTextField();
		jIbisTF.setMargin(new java.awt.Insets(0,0,0,0));
		jIbisTF.setBounds(105,0,89,20);
		jIbisTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jIbisNmPanel.add("Center", jIbisTF);

		jBufPanel = new javax.swing.JPanel();
		jBufPanel.setLayout(new BorderLayout(70,0));
		jBufPanel.setBounds(0,30,194,20);
		jBufPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLeftNodePanel.add(jBufPanel);

		jBufLabel = new javax.swing.JLabel();
		jBufLabel.setText("Buffer ");
		jBufLabel.setBounds(0,0,35,20);
		jBufLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jBufPanel.add("West", jBufLabel);

		jBufCB = new javax.swing.JComboBox();
		jBufCB.setEditable(true);
		jBufCB.setBounds(105,0,89,20);
		jBufCB.setFont(new Font("Dialog", Font.BOLD, 12));
		jBufPanel.add("Center", jBufCB);

		jPowNodePanel = new javax.swing.JPanel();
		jPowNodePanel.setLayout(new BorderLayout(70,0));
		jPowNodePanel.setBounds(0,60,194,20);
		jPowNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLeftNodePanel.add(jPowNodePanel);
        
		jPowNodeLabel = new javax.swing.JLabel();
		jPowNodeLabel.setText("Power");
		jPowNodeLabel.setBounds(0,0,35,20);
		jPowNodeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPowNodePanel.add("West", jPowNodeLabel);
        
		jPowNodeCB = new javax.swing.JComboBox();
		jPowNodeCB.setEditable(true);
		jPowNodeCB.setBounds(105,0,89,20);
		jPowNodeCB.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPowNodePanel.add("Center", jPowNodeCB);

		jGndNodePanel = new javax.swing.JPanel();
		jGndNodePanel.setLayout(new BorderLayout(65,0));
		jGndNodePanel.setBounds(0,90,194,20);
		jGndNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLeftNodePanel.add(jGndNodePanel);
        
		jGndNodeLabel = new javax.swing.JLabel();
		jGndNodeLabel.setText("Ground");
		jGndNodeLabel.setBounds(0,0,41,20);
		jGndNodeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jGndNodePanel.add("West", jGndNodeLabel);
        
		jGndNodeCB = new javax.swing.JComboBox();
		jGndNodeCB.setEditable(true);
		jGndNodeCB.setBounds(106,0,88,20);
		jGndNodeCB.setFont(new Font("Dialog", Font.BOLD, 12));
		jGndNodePanel.add("Center", jGndNodeCB);
        
		jInNodePanel = new javax.swing.JPanel();
		jInNodePanel.setRequestFocusEnabled(false);
		jInNodePanel.setLayout(new BorderLayout(45,0));
		jInNodePanel.setBounds(0,120,194,20);
		jInNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLeftNodePanel.add(jInNodePanel);
        
		jInNodeLabel = new javax.swing.JLabel();
		jInNodeLabel.setText("Buffer Input");
		jInNodeLabel.setBounds(0,0,62,20);
		jInNodeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jInNodePanel.add("West", jInNodeLabel);
        
		jInNodeCB = new javax.swing.JComboBox();
		jInNodeCB.setEditable(true);
		jInNodeCB.setBounds(107,0,87,20);
		jInNodeCB.setFont(new Font("Dialog", Font.BOLD, 12));
		jInNodePanel.add("Center", jInNodeCB);
        
		jEnNodePanel = new javax.swing.JPanel();
		jEnNodePanel.setLayout(new BorderLayout(32,0));
		jEnNodePanel.setBounds(0,150,194,20);
		jEnNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLeftNodePanel.add(jEnNodePanel);
        
		jEnNodeLabel = new javax.swing.JLabel();
		jEnNodeLabel.setText("Buffer Enable");
		jEnNodeLabel.setBounds(0,0,74,20);
		jEnNodeLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jEnNodePanel.add("West", jEnNodeLabel);
        
		jEnNodeCB = new javax.swing.JComboBox();
		jEnNodeCB.setEditable(true);
		jEnNodeCB.setBounds(106,0,88,20);
		jEnNodeCB.setFont(new Font("Dialog", Font.BOLD, 12));
		jEnNodePanel.add("Center", jEnNodeCB);
        
		jRightNodePanel = new javax.swing.JPanel();
		jRightNodePanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jRightNodePanel.setBounds(204,0,194,294);
		jRightNodePanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNodePanel.add(jRightNodePanel);

		jModInfoPanel = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		jModInfoPanel.setLayout(gridBagLayout);
		jModInfoPanel.setVisible(false);
		jModInfoPanel.setBounds(0,0,398,294);
		jModInfoPanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jModInfoPanel1 = new javax.swing.JPanel();
		jModInfoPanel1.setLayout(new GridLayout(3,4,20,5));
		jModInfoPanel1.setBounds(0,0,398,67);
		jModInfoPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jModInfoPanel.getLayout()).setConstraints(jModInfoPanel1, gbc);
		jModInfoPanel.add(jModInfoPanel1);
        
		jLowThreshLabel = new javax.swing.JLabel();
		jLowThreshLabel.setText("Low");
		jLowThreshLabel.setBounds(0,24,84,19);
		jLowThreshLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel1.add(jLowThreshLabel);
        
		jLoThreshTypTF = new javax.swing.JTextField();
		jLoThreshTypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jLoThreshTypTF.setBounds(104,24,84,19);
		jLoThreshTypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jModInfoPanel1.add(jLoThreshTypTF);
        
		jHiThreshLabel = new javax.swing.JLabel();
		jHiThreshLabel.setText("High");
		jHiThreshLabel.setBounds(0,48,84,19);
		jHiThreshLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel1.add(jHiThreshLabel);
        
		jHiThreshTypTF = new javax.swing.JTextField();
		jHiThreshTypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jHiThreshTypTF.setBounds(104,48,84,19);
		jHiThreshTypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jModInfoPanel1.add(jHiThreshTypTF);
        
		jModInfoPanel2 = new javax.swing.JPanel();
		jModInfoPanel2.setLayout(new GridLayout(2,4,20,5));
		jModInfoPanel2.setBounds(0,77,398,43);
		jModInfoPanel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(10,0,10,0);
		((GridBagLayout)jModInfoPanel.getLayout()).setConstraints(jModInfoPanel2, gbc);
		jModInfoPanel.add(jModInfoPanel2);
        
		jBlankLabel2 = new javax.swing.JLabel();
		jBlankLabel2.setBounds(0,0,84,19);
		jBlankLabel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel2.add(jBlankLabel2);
        
		jTypLabel3 = new javax.swing.JLabel();
		jTypLabel3.setText("Typical");
		jTypLabel3.setBounds(104,0,84,19);
		jTypLabel3.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel2.add(jTypLabel3);
        
		jMinLabel13 = new javax.swing.JLabel();
		jMinLabel13.setText("Minimum");
		jMinLabel13.setBounds(208,0,84,19);
		jMinLabel13.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel2.add(jMinLabel13);
        
		jMaxLabel13 = new javax.swing.JLabel();
		jMaxLabel13.setText("Maximum");
		jMaxLabel13.setBounds(312,0,84,19);
		jMaxLabel13.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel2.add(jMaxLabel13);
        
		jCcompLabel = new javax.swing.JLabel();
		jCcompLabel.setText("Ccomp");
		jCcompLabel.setBounds(0,24,84,19);
		jCcompLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel2.add(jCcompLabel);
        
		jCcompCtypTF = new javax.swing.JTextField();
		jCcompCtypTF.setMargin(new java.awt.Insets(0,0,0,0));
		jCcompCtypTF.setBounds(104,24,84,19);
		jCcompCtypTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jModInfoPanel2.add(jCcompCtypTF);
        
		jCcompCminTF = new javax.swing.JTextField();
		jCcompCminTF.setMargin(new java.awt.Insets(0,0,0,0));
		jCcompCminTF.setBounds(208,24,84,19);
		jCcompCminTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jModInfoPanel2.add(jCcompCminTF);
        
		jCcompCmaxTF = new javax.swing.JTextField();
		jCcompCmaxTF.setMargin(new java.awt.Insets(0,0,0,0));
		jCcompCmaxTF.setBounds(312,24,84,19);
		jCcompCmaxTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jModInfoPanel2.add(jCcompCmaxTF);
        
		jModInfoPanel3 = new javax.swing.JPanel();
		jModInfoPanel3.setAlignmentX(0.0F);
		jModInfoPanel3.setLayout(new BoxLayout(jModInfoPanel3,BoxLayout.Y_AXIS));
		jModInfoPanel3.setBounds(0,130,398,50);
		jModInfoPanel3.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.weightx = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jModInfoPanel.getLayout()).setConstraints(jModInfoPanel3, gbc);
		jModInfoPanel.add(jModInfoPanel3);
        
		jPolarityCB = new javax.swing.JCheckBox();
		jPolarityCB.setText("Inverting  [Polarity]");
		jPolarityCB.setActionCommand("Non-inverting  [Polarity]");
		jPolarityCB.setBounds(0,0,125,25);
		jPolarityCB.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel3.add(jPolarityCB);
        
		jActiveHighCB = new javax.swing.JCheckBox();
		jActiveHighCB.setText("Active-High [Enable]");
		jActiveHighCB.setActionCommand("Active-High [Enable]");
		jActiveHighCB.setBounds(0,25,136,25);
		jActiveHighCB.setFont(new Font("Dialog", Font.PLAIN, 12));
		jModInfoPanel3.add(jActiveHighCB);
        
		jModInfoPanel4 = new javax.swing.JPanel();
		jModInfoPanel4.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jModInfoPanel4.setBounds(0,180,398,114);
		jModInfoPanel4.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.weightx = 0.1;
		gbc.weighty = 0.7;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jModInfoPanel.getLayout()).setConstraints(jModInfoPanel4, gbc);
		jModInfoPanel.add(jModInfoPanel4);
        
		jDelayPanel = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		jDelayPanel.setLayout(gridBagLayout);
		jDelayPanel.setVisible(false);
		jDelayPanel.setBounds(0,0,398,294);
		jDelayPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
        
		jNWDelayPanel = new javax.swing.JPanel();
		jNWDelayPanel.setLayout(new GridLayout(5,1,0,10));
		jNWDelayPanel.setBounds(0,0,127,135);
		jNWDelayPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jDelayPanel.getLayout()).setConstraints(jNWDelayPanel, gbc);
		jDelayPanel.add(jNWDelayPanel);
        
		jDelayBlankLabel = new javax.swing.JLabel();
		jDelayBlankLabel.setBounds(0,0,63,19);
		jDelayBlankLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		jNWDelayPanel.add(jDelayBlankLabel);
        
		jDelayBlankLabel2 = new javax.swing.JLabel();
		jDelayBlankLabel2.setBounds(63,0,63,19);
		jDelayBlankLabel2.setFont(new Font("Dialog", Font.BOLD, 12));
		jNWDelayPanel.add(jDelayBlankLabel2);
        
		jVmeasLabel = new javax.swing.JLabel();
		jVmeasLabel.setText("[Vmeas]");
		jVmeasLabel.setBounds(0,29,63,19);
		jVmeasLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNWDelayPanel.add(jVmeasLabel);
        
		jVmeasTF = new javax.swing.JTextField();
		jVmeasTF.setMargin(new java.awt.Insets(0,0,0,0));
		jVmeasTF.setBounds(63,29,63,19);
		jVmeasTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jNWDelayPanel.add(jVmeasTF);
        
		jVrefLabel = new javax.swing.JLabel();
		jVrefLabel.setText("[Vref]");
		jVrefLabel.setBounds(0,58,63,19);
		jVrefLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNWDelayPanel.add(jVrefLabel);
        
		jVrefTF = new javax.swing.JTextField();
		jVrefTF.setMargin(new java.awt.Insets(0,0,0,0));
		jVrefTF.setBounds(63,58,63,19);
		jVrefTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jNWDelayPanel.add(jVrefTF);
        
		jCrefLabel = new javax.swing.JLabel();
		jCrefLabel.setText("[Cref]");
		jCrefLabel.setBounds(0,87,63,19);
		jCrefLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNWDelayPanel.add(jCrefLabel);
        
		jCrefTF = new javax.swing.JTextField();
		jCrefTF.setMargin(new java.awt.Insets(0,0,0,0));
		jCrefTF.setBounds(63,87,63,19);
		jCrefTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jNWDelayPanel.add(jCrefTF);
        
		jRrefLabel = new javax.swing.JLabel();
		jRrefLabel.setText("[Rref]");
		jRrefLabel.setBounds(0,116,63,19);
		jRrefLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jNWDelayPanel.add(jRrefLabel);
        
		jRrefTF = new javax.swing.JTextField();
		jRrefTF.setMargin(new java.awt.Insets(0,0,0,0));
		jRrefTF.setBounds(63,116,63,19);
		jRrefTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jNWDelayPanel.add(jRrefTF);
        
		jNEDelayPanel = new javax.swing.JPanel();
		jNEDelayPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jNEDelayPanel.setBounds(127,62,270,10);
		jNEDelayPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.weightx = 0.7;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jDelayPanel.getLayout()).setConstraints(jNEDelayPanel, gbc);
		jDelayPanel.add(jNEDelayPanel);
        
		jSouthDelayPanel = new javax.swing.JPanel();
		jSouthDelayPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jSouthDelayPanel.setBounds(0,135,397,159);
		jSouthDelayPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.gridwidth = 2;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jDelayPanel.getLayout()).setConstraints(jSouthDelayPanel, gbc);
		jDelayPanel.add(jSouthDelayPanel);
        
		jVT1Panel = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		jVT1Panel.setLayout(gridBagLayout);
		jVT1Panel.setVisible(false);
		jVT1Panel.setBounds(0,0,398,294);
		jVT1Panel.setFont(new Font("Dialog", Font.PLAIN, 12));
        
		jRisePanel1 = new javax.swing.JPanel();
		jRisePanel1.setLayout(new GridLayout(5,4,0,0));
		jRisePanel1.setBounds(0,4,398,95);
		jRisePanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.weighty = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jVT1Panel.getLayout()).setConstraints(jRisePanel1, gbc);
		jVT1Panel.add(jRisePanel1);
        
		jLabel31 = new javax.swing.JLabel();
		jLabel31.setBounds(0,0,99,19);
		jLabel31.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel31);
        
		jLabel32 = new javax.swing.JLabel();
		jLabel32.setText("Typical");
		jLabel32.setBounds(99,0,99,19);
		jLabel32.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel32);
        
		jLabel33 = new javax.swing.JLabel();
		jLabel33.setText("Minimum");
		jLabel33.setBounds(198,0,99,19);
		jLabel33.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel33);
        
		jLabel34 = new javax.swing.JLabel();
		jLabel34.setText("Maximum");
		jLabel34.setBounds(297,0,99,19);
		jLabel34.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel34);
        
		jLabel35 = new javax.swing.JLabel();
		jLabel35.setText("V_fix");
		jLabel35.setBounds(0,19,99,19);
		jLabel35.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel35);
        
		jRwaveVf1TF = new javax.swing.JTextField();
		jRwaveVf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveVf1TF.setBounds(99,19,99,19);
		jRwaveVf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveVf1TF);
        
		jRwaveVfMin1TF = new javax.swing.JTextField();
		jRwaveVfMin1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveVfMin1TF.setBounds(198,19,99,19);
		jRwaveVfMin1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveVfMin1TF);
        
		jRwaveVfMax1TF = new javax.swing.JTextField();
		jRwaveVfMax1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveVfMax1TF.setBounds(297,19,99,19);
		jRwaveVfMax1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveVfMax1TF);
        
		jLabel36 = new javax.swing.JLabel();
		jLabel36.setBounds(0,38,99,19);
		jLabel36.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel36);
        
		jLabel37 = new javax.swing.JLabel();
		jLabel37.setText("R");
		jLabel37.setBounds(99,38,99,19);
		jLabel37.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel37);
        
		jLabel38 = new javax.swing.JLabel();
		jLabel38.setText("L");
		jLabel38.setBounds(198,38,99,19);
		jLabel38.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel38);
        
		jLabel39 = new javax.swing.JLabel();
		jLabel39.setText("C");
		jLabel39.setBounds(297,38,99,19);
		jLabel39.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel39);
        
		jLabel40 = new javax.swing.JLabel();
		jLabel40.setText("Fixture");
		jLabel40.setBounds(0,57,99,19);
		jLabel40.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel40);
        
		jRwaveRf1TF = new javax.swing.JTextField();
		jRwaveRf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveRf1TF.setBounds(99,57,99,19);
		jRwaveRf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveRf1TF);
        
		jRwaveLf1TF = new javax.swing.JTextField();
		jRwaveLf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveLf1TF.setBounds(198,57,99,19);
		jRwaveLf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveLf1TF);
        
		jRwaveCf1TF = new javax.swing.JTextField();
		jRwaveCf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveCf1TF.setBounds(297,57,99,19);
		jRwaveCf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveCf1TF);
        
		jLabel41 = new javax.swing.JLabel();
		jLabel41.setText("DUT");
		jLabel41.setBounds(0,76,99,19);
		jLabel41.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel1.add(jLabel41);

		jRwaveRd1TF = new javax.swing.JTextField();
		jRwaveRd1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveRd1TF.setBounds(99,76,99,19);
		jRwaveRd1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveRd1TF);
        
		jRwaveLd1TF = new javax.swing.JTextField();
		jRwaveLd1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveLd1TF.setBounds(198,76,99,19);
		jRwaveLd1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveLd1TF);
        
		jRwaveCd1TF = new javax.swing.JTextField();
		jRwaveCd1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveCd1TF.setBounds(297,76,99,19);
		jRwaveCd1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel1.add(jRwaveCd1TF);
        
		jFallPanel1 = new javax.swing.JPanel();
		jFallPanel1.setLayout(new GridLayout(5,4,0,0));
		jFallPanel1.setBounds(0,104,398,95);
		jFallPanel1.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jVT1Panel.getLayout()).setConstraints(jFallPanel1, gbc);
		jVT1Panel.add(jFallPanel1);
        
		jLabel42 = new javax.swing.JLabel();
		jLabel42.setBounds(0,0,99,19);
		jLabel42.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel42);
        
		jLabel43 = new javax.swing.JLabel();
		jLabel43.setText("Typical");
		jLabel43.setBounds(99,0,99,19);
		jLabel43.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel43);
        
		jLabel44 = new javax.swing.JLabel();
		jLabel44.setText("Minimum");
		jLabel44.setBounds(198,0,99,19);
		jLabel44.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel44);
        
		jLabel45 = new javax.swing.JLabel();
		jLabel45.setText("Maximum");
		jLabel45.setBounds(297,0,99,19);
		jLabel45.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel45);
        
		jLabel46 = new javax.swing.JLabel();
		jLabel46.setText("V_fix");
		jLabel46.setBounds(0,19,99,19);
		jLabel46.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel46);
        
		jFwaveVf1TF = new javax.swing.JTextField();
		jFwaveVf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveVf1TF.setBounds(99,19,99,19);
		jFwaveVf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveVf1TF);
        
		jFwaveVfMin1TF = new javax.swing.JTextField();
		jFwaveVfMin1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveVfMin1TF.setBounds(198,19,99,19);
		jFwaveVfMin1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveVfMin1TF);
        
		jFwaveVfMax1TF = new javax.swing.JTextField();
		jFwaveVfMax1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveVfMax1TF.setBounds(297,19,99,19);
		jFwaveVfMax1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveVfMax1TF);
        
		jLabel47 = new javax.swing.JLabel();
		jLabel47.setBounds(0,38,99,19);
		jLabel47.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel47);
        
		jLabel48 = new javax.swing.JLabel();
		jLabel48.setText("R");
		jLabel48.setBounds(99,38,99,19);
		jLabel48.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel48);
        
		jLabel49 = new javax.swing.JLabel();
		jLabel49.setText("L");
		jLabel49.setBounds(198,38,99,19);
		jLabel49.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel49);
        
		jLabel50 = new javax.swing.JLabel();
		jLabel50.setText("C");
		jLabel50.setBounds(297,38,99,19);
		jLabel50.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel50);
        
		jLabel51 = new javax.swing.JLabel();
		jLabel51.setText("Fixture");
		jLabel51.setBounds(0,57,99,19);
		jLabel51.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel51);
        
		jFwaveRf1TF = new javax.swing.JTextField();
		jFwaveRf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveRf1TF.setBounds(99,57,99,19);
		jFwaveRf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveRf1TF);
        
		jFwaveLf1TF = new javax.swing.JTextField();
		jFwaveLf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveLf1TF.setBounds(198,57,99,19);
		jFwaveLf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveLf1TF);
        
		jFwaveCf1TF = new javax.swing.JTextField();
		jFwaveCf1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveCf1TF.setBounds(297,57,99,19);
		jFwaveCf1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveCf1TF);
        
		jLabel52 = new javax.swing.JLabel();
		jLabel52.setText("DUT");
		jLabel52.setBounds(0,76,99,19);
		jLabel52.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel1.add(jLabel52);
        
		jFwaveRd1TF = new javax.swing.JTextField();
		jFwaveRd1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveRd1TF.setBounds(99,76,99,19);
		jFwaveRd1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveRd1TF);
        
		jFwaveLd1TF = new javax.swing.JTextField();
		jFwaveLd1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveLd1TF.setBounds(198,76,99,19);
		jFwaveLd1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveLd1TF);
        
		jFwaveCd1TF = new javax.swing.JTextField();
		jFwaveCd1TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveCd1TF.setBounds(297,76,99,19);
		jFwaveCd1TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel1.add(jFwaveCd1TF);
        
		jVT1BlankPanel = new javax.swing.JPanel();
		jVT1BlankPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jVT1BlankPanel.setBounds(0,199,398,94);
		jVT1BlankPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.weightx = 0.1;
		gbc.weighty = 0.9;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jVT1Panel.getLayout()).setConstraints(jVT1BlankPanel, gbc);
		jVT1Panel.add(jVT1BlankPanel);
        
		jVT2Panel = new javax.swing.JPanel();
		gridBagLayout = new GridBagLayout();
		jVT2Panel.setLayout(gridBagLayout);
		jVT2Panel.setVisible(false);
		jVT2Panel.setBounds(0,0,398,294);
		jVT2Panel.setFont(new Font("Dialog", Font.PLAIN, 12));
        
		jRisePanel2 = new javax.swing.JPanel();
		jRisePanel2.setLayout(new GridLayout(5,4,0,0));
		jRisePanel2.setBounds(0,4,398,95);
		jRisePanel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 0.1;
		gbc.weighty = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jVT2Panel.getLayout()).setConstraints(jRisePanel2, gbc);
		jVT2Panel.add(jRisePanel2);
        
		jLabel9 = new javax.swing.JLabel();
		jLabel9.setBounds(0,0,99,19);
		jLabel9.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel9);
        
		jLabel10 = new javax.swing.JLabel();
		jLabel10.setText("Typical");
		jLabel10.setBounds(99,0,99,19);
		jLabel10.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel10);

		jLabel11 = new javax.swing.JLabel();
		jLabel11.setText("Minimum");
		jLabel11.setBounds(198,0,99,19);
		jLabel11.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel11);
        
		jLabel12 = new javax.swing.JLabel();
		jLabel12.setText("Maximum");
		jLabel12.setBounds(297,0,99,19);
		jLabel12.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel12);
        
		jLabel13 = new javax.swing.JLabel();
		jLabel13.setText("V_fix");
		jLabel13.setBounds(0,19,99,19);
		jLabel13.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel13);
        
		jRwaveVf2TF = new javax.swing.JTextField();
		jRwaveVf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveVf2TF.setBounds(99,19,99,19);
		jRwaveVf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveVf2TF);
        
		jRwaveVfMin2TF = new javax.swing.JTextField();
		jRwaveVfMin2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveVfMin2TF.setBounds(198,19,99,19);
		jRwaveVfMin2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveVfMin2TF);
        
		jRwaveVfMax2TF = new javax.swing.JTextField();
		jRwaveVfMax2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveVfMax2TF.setBounds(297,19,99,19);
		jRwaveVfMax2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveVfMax2TF);
        
		jLabel14 = new javax.swing.JLabel();
		jLabel14.setBounds(0,38,99,19);
		jLabel14.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel14);
        
		jLabel15 = new javax.swing.JLabel();
		jLabel15.setText("R");
		jLabel15.setBounds(99,38,99,19);
		jLabel15.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel15);
        
		jLabel16 = new javax.swing.JLabel();
		jLabel16.setText("L");
		jLabel16.setBounds(198,38,99,19);
		jLabel16.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel16);
        
		jLabel17 = new javax.swing.JLabel();
		jLabel17.setText("C");
		jLabel17.setBounds(297,38,99,19);
		jLabel17.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel17);
        
		jLabel18 = new javax.swing.JLabel();
		jLabel18.setText("Fixture");
		jLabel18.setBounds(0,57,99,19);
		jLabel18.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel18);
        
		jRwaveRf2TF = new javax.swing.JTextField();
		jRwaveRf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveRf2TF.setBounds(99,57,99,19);
		jRwaveRf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveRf2TF);
        
		jRwaveLf2TF = new javax.swing.JTextField();
		jRwaveLf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveLf2TF.setBounds(198,57,99,19);
		jRwaveLf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveLf2TF);
        
		jRwaveCf2TF = new javax.swing.JTextField();
		jRwaveCf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveCf2TF.setBounds(297,57,99,19);
		jRwaveCf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveCf2TF);
        
		jLabel19 = new javax.swing.JLabel();
		jLabel19.setText("DUT");
		jLabel19.setBounds(0,76,99,19);
		jLabel19.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRisePanel2.add(jLabel19);
        
		jRwaveRd2TF = new javax.swing.JTextField();
		jRwaveRd2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveRd2TF.setBounds(99,76,99,19);
		jRwaveRd2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveRd2TF);
        
		jRwaveLd2TF = new javax.swing.JTextField();
		jRwaveLd2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveLd2TF.setBounds(198,76,99,19);
		jRwaveLd2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveLd2TF);
        
		jRwaveCd2TF = new javax.swing.JTextField();
		jRwaveCd2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jRwaveCd2TF.setBounds(297,76,99,19);
		jRwaveCd2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRisePanel2.add(jRwaveCd2TF);
        
		jFallPanel2 = new javax.swing.JPanel();
		jFallPanel2.setLayout(new GridLayout(5,4,0,0));
		jFallPanel2.setBounds(0,104,398,95);
		jFallPanel2.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 0.1;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jVT2Panel.getLayout()).setConstraints(jFallPanel2, gbc);
		jVT2Panel.add(jFallPanel2);
        
		jLabel20 = new javax.swing.JLabel();
		jLabel20.setBounds(0,0,99,19);
		jLabel20.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel20);
        
		jLabel21 = new javax.swing.JLabel();
		jLabel21.setText("Typical");
		jLabel21.setBounds(99,0,99,19);
		jLabel21.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel21);
        
		jLabel22 = new javax.swing.JLabel();
		jLabel22.setText("Minimum");
		jLabel22.setBounds(198,0,99,19);
		jLabel22.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel22);
        
		jLabel23 = new javax.swing.JLabel();
		jLabel23.setText("Maximum");
		jLabel23.setBounds(297,0,99,19);
		jLabel23.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel23);
        
		jLabel24 = new javax.swing.JLabel();
		jLabel24.setText("V_fix");
		jLabel24.setBounds(0,19,99,19);
		jLabel24.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel24);
        
		jFwaveVf2TF = new javax.swing.JTextField();
		jFwaveVf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveVf2TF.setBounds(99,19,99,19);
		jFwaveVf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveVf2TF);
        
		jFwaveVfMin2TF = new javax.swing.JTextField();
		jFwaveVfMin2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveVfMin2TF.setBounds(198,19,99,19);
		jFwaveVfMin2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveVfMin2TF);
        
		jFwaveVfMax2TF = new javax.swing.JTextField();
		jFwaveVfMax2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveVfMax2TF.setBounds(297,19,99,19);
		jFwaveVfMax2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveVfMax2TF);
        
		jLabel25 = new javax.swing.JLabel();
		jLabel25.setBounds(0,38,99,19);
		jLabel25.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel25);
        
		jLabel26 = new javax.swing.JLabel();
		jLabel26.setText("R");
		jLabel26.setBounds(99,38,99,19);
		jLabel26.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel26);
        
		jLabel27 = new javax.swing.JLabel();
		jLabel27.setText("L");
		jLabel27.setBounds(198,38,99,19);
		jLabel27.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel27);
        
		jLabel28 = new javax.swing.JLabel();
		jLabel28.setText("C");
		jLabel28.setBounds(297,38,99,19);
		jLabel28.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel28);
        
		jLabel29 = new javax.swing.JLabel();
		jLabel29.setText("Fixture");
		jLabel29.setBounds(0,57,99,19);
		jLabel29.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel29);
        
		jFwaveRf2TF = new javax.swing.JTextField();
		jFwaveRf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveRf2TF.setBounds(99,57,99,19);
		jFwaveRf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveRf2TF);
        
		jFwaveLf2TF = new javax.swing.JTextField();
		jFwaveLf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveLf2TF.setBounds(198,57,99,19);
		jFwaveLf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveLf2TF);
        
		jFwaveCf2TF = new javax.swing.JTextField();
		jFwaveCf2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveCf2TF.setBounds(297,57,99,19);
		jFwaveCf2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveCf2TF);
        
		jLabel30 = new javax.swing.JLabel();
		jLabel30.setText("DUT");
		jLabel30.setBounds(0,76,99,19);
		jLabel30.setFont(new Font("Dialog", Font.PLAIN, 12));
		jFallPanel2.add(jLabel30);
        
		jFwaveRd2TF = new javax.swing.JTextField();
		jFwaveRd2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveRd2TF.setBounds(99,76,99,19);
		jFwaveRd2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveRd2TF);
        
		jFwaveLd2TF = new javax.swing.JTextField();
		jFwaveLd2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveLd2TF.setBounds(198,76,99,19);
		jFwaveLd2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveLd2TF);
        
		jFwaveCd2TF = new javax.swing.JTextField();
		jFwaveCd2TF.setMargin(new java.awt.Insets(0,0,0,0));
		jFwaveCd2TF.setBounds(297,76,99,19);
		jFwaveCd2TF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jFallPanel2.add(jFwaveCd2TF);
        
		jVT2BlankPanel = new javax.swing.JPanel();
		jVT2BlankPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jVT2BlankPanel.setBounds(0,199,398,94);
		jVT2BlankPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.weightx = 0.1;
		gbc.weighty = 0.9;
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)jVT2Panel.getLayout()).setConstraints(jVT2BlankPanel, gbc);
		jVT2Panel.add(jVT2BlankPanel);
        
		jRLoadPanel = new javax.swing.JPanel();
		jRLoadPanel.setLayout(new BorderLayout(0,10));
		jRLoadPanel.setVisible(false);
		jRLoadPanel.setBounds(0,0,398,294);
		jRLoadPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
        
		jRLoadNorthPanel = new javax.swing.JPanel();
		jRLoadNorthPanel.setLayout(new GridLayout(1,1,0,0));
		jRLoadNorthPanel.setBounds(0,0,398,19);
		jRLoadNorthPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRLoadPanel.add("North", jRLoadNorthPanel);
        
		jRLoadLabel = new javax.swing.JLabel();
		jRLoadLabel.setText("[RLoad]");
		jRLoadLabel.setBounds(0,0,66,19);
		jRLoadLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jRLoadNorthPanel.add(jRLoadLabel);
        
		jRloadTF = new javax.swing.JTextField();
		jRloadTF.setMargin(new java.awt.Insets(0,0,0,0));
		jRloadTF.setBounds(66,0,66,19);
		jRloadTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jRLoadNorthPanel.add(jRloadTF);
        
		jRLoadLabel2 = new javax.swing.JLabel();
		jRLoadLabel2.setBounds(132,0,66,19);
		jRLoadLabel2.setFont(new Font("Dialog", Font.BOLD, 12));
		jRLoadNorthPanel.add(jRLoadLabel2);
        
		jRLoadLabel3 = new javax.swing.JLabel();
		jRLoadLabel3.setBounds(198,0,66,19);
		jRLoadLabel3.setFont(new Font("Dialog", Font.BOLD, 12));
		jRLoadNorthPanel.add(jRLoadLabel3);
        
		jRLoadLabel4 = new javax.swing.JLabel();
		jRLoadLabel4.setBounds(264,0,66,19);
		jRLoadLabel4.setFont(new Font("Dialog", Font.BOLD, 12));
		jRLoadNorthPanel.add(jRLoadLabel4);
        
		jRLoadLabel5 = new javax.swing.JLabel();
		jRLoadLabel5.setBounds(330,0,66,19);
		jRLoadLabel5.setFont(new Font("Dialog", Font.BOLD, 12));
		jRLoadNorthPanel.add(jRLoadLabel5);
        
		jPostProcPanel = new javax.swing.JPanel();
		jPostProcPanel.setLayout(new BorderLayout(2,0));
		jPostProcPanel.setVisible(false);
		jPostProcPanel.setBounds(0,0,398,294);
		jPostProcPanel.setFont(new Font("Dialog", Font.PLAIN, 12));

		jLPostProcPanel = new javax.swing.JPanel();
		jLPostProcPanel.setLayout(new GridLayout(10,1,0,10));
		jLPostProcPanel.setBounds(0,0,220,294);
		jLPostProcPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPostProcPanel.add("West", jLPostProcPanel);
        
		jDerVIPanel = new javax.swing.JPanel();
		jDerVIPanel.setLayout(new GridLayout(1,1,0,0));
		jDerVIPanel.setBounds(0,0,220,20);
		jDerVIPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLPostProcPanel.add(jDerVIPanel);
        
		jDerVILabel = new javax.swing.JLabel();
		jDerVILabel.setText("[Derate VI]");
		jDerVILabel.setBounds(0,0,110,20);
		jDerVILabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jDerVIPanel.add(jDerVILabel);
        
		jDerVIRPanel = new javax.swing.JPanel();
		jDerVIRPanel.setLayout(new BorderLayout(0,0));
		jDerVIRPanel.setBounds(110,0,110,20);
		jDerVIRPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jDerVIPanel.add(jDerVIRPanel);
        
		jDerVITF = new javax.swing.JTextField();
		jDerVITF.setMargin(new java.awt.Insets(0,0,0,0));
		jDerVITF.setBounds(0,0,38,20);
		jDerVITF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jDerVIRPanel.add("Center", jDerVITF);
        
		jDerVILabel2 = new javax.swing.JLabel();
		jDerVILabel2.setText(" %                    ");
		jDerVILabel2.setBounds(38,0,72,20);
		jDerVILabel2.setFont(new Font("Dialog", Font.BOLD, 12));
		jDerVIRPanel.add("East", jDerVILabel2);
        
		jDerRampPanel = new javax.swing.JPanel();
		jDerRampPanel.setLayout(new GridLayout(1,1,0,0));
		jDerRampPanel.setBounds(0,30,220,20);
		jDerRampPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLPostProcPanel.add(jDerRampPanel);
        
		jDerRampLabel = new javax.swing.JLabel();
		jDerRampLabel.setText("[Derate Ramp]          ");
		jDerRampLabel.setBounds(0,0,110,20);
		jDerRampLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jDerRampPanel.add(jDerRampLabel);
        
		jDerRampRPanel = new javax.swing.JPanel();
		jDerRampRPanel.setLayout(new BorderLayout(0,0));
		jDerRampRPanel.setBounds(110,0,110,20);
		jDerRampRPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jDerRampPanel.add(jDerRampRPanel);
        
		jDerRampTF = new javax.swing.JTextField();
		jDerRampTF.setMargin(new java.awt.Insets(0,0,0,0));
		jDerRampTF.setBounds(0,0,38,20);
		jDerRampTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jDerRampRPanel.add("Center", jDerRampTF);
        
		jDerRampLabel2 = new javax.swing.JLabel();
		jDerRampLabel2.setText(" %                    ");
		jDerRampLabel2.setBounds(38,0,72,20);
		jDerRampLabel2.setFont(new Font("Dialog", Font.BOLD, 12));
		jDerRampRPanel.add("East", jDerRampLabel2);
        
		jClampTolPanel = new javax.swing.JPanel();
		jClampTolPanel.setLayout(new BorderLayout(0,0));
		jClampTolPanel.setBounds(0,60,220,20);
		jClampTolPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jLPostProcPanel.add(jClampTolPanel);
		jClampTolLabel = new javax.swing.JLabel();
		jClampTolLabel.setText("[Clamp Tolerance]   ");
		jClampTolLabel.setBounds(0,0,110,20);
		jClampTolLabel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jClampTolPanel.add("West", jClampTolLabel);

		jClampTolRPanel = new javax.swing.JPanel();
		jClampTolRPanel.setLayout(new BorderLayout(0,0));
		jClampTolRPanel.setBounds(110,0,110,20);
		jClampTolRPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jClampTolPanel.add("Center", jClampTolRPanel);
        
		jClampTolTF = new javax.swing.JTextField();
		jClampTolTF.setMargin(new java.awt.Insets(0,0,0,0));
		jClampTolTF.setBounds(0,0,38,20);
		jClampTolTF.setFont(new Font("SansSerif", Font.PLAIN, 12));
		jClampTolRPanel.add("Center", jClampTolTF);
        
		jClampTolLabel2 = new javax.swing.JLabel();
		jClampTolLabel2.setText(" %                    ");
		jClampTolLabel2.setBounds(38,0,72,20);
		jClampTolLabel2.setFont(new Font("Dialog", Font.BOLD, 12));
		jClampTolRPanel.add("East", jClampTolLabel2);
        
		jRPostProcPanel = new javax.swing.JPanel();
		jRPostProcPanel.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		jRPostProcPanel.setBounds(222,0,176,294);
		jRPostProcPanel.setFont(new Font("Dialog", Font.PLAIN, 12));
		jPostProcPanel.add("Center", jRPostProcPanel);
        
		jCenterPanel.add("Nodes", jNodePanel);
		jCenterPanel.add("Mode", jModePanel);
		jCenterPanel.add("Model Information", jModInfoPanel);
		jCenterPanel.add("Voltage", jVOpPanel);
		jCenterPanel.add("Stimulus", jStimulusPanel);
		jCenterPanel.add("VT-1", jVT1Panel);
		jCenterPanel.add("VT-2", jVT2Panel);
		jCenterPanel.add("Ramp Load", jRLoadPanel);
		jCenterPanel.add("Buffer Delay", jDelayPanel);
		jCenterPanel.add("Temperature", jTOpPanel);
		jCenterPanel.add("Post Processing", jPostProcPanel);
		getContentPane().add("Center", jCenterPanel);
		//}}

		//{{Non-symantec Init controls
		//Set up the borders properly.
		jModePanel.setBorder(BorderFactory.createMatteBorder
		                      (10,10,10,10,this.getBackground()) );
		jStimulusPanel.setBorder(BorderFactory.createMatteBorder
		                      (10,10,10,10,this.getBackground()) );

		jRangePanel.setBorder(BorderFactory.createTitledBorder("Voltage Range"));
		jRefPanel.setBorder(BorderFactory.createTitledBorder("Reference Values"));

		jModInfoPanel1.setBorder(BorderFactory.createCompoundBorder(
		        BorderFactory.createMatteBorder(0,0,0,30,this.getBackground()),
		        BorderFactory.createTitledBorder("Input Thresholds")) );
		jModInfoPanel2.setBorder(BorderFactory.createCompoundBorder(
		        BorderFactory.createMatteBorder(0,0,0,30,this.getBackground()),
		        BorderFactory.createTitledBorder("Device capacitance")) );

		jRisePanel1.setBorder(BorderFactory.createTitledBorder("Rising Waveform 1"));
		jFallPanel1.setBorder(BorderFactory.createTitledBorder("Falling Waveform 1"));
		jRisePanel2.setBorder(BorderFactory.createTitledBorder("Rising Waveform 2"));
		jFallPanel2.setBorder(BorderFactory.createTitledBorder("Falling Waveform 2"));

		//Initialize the fields
		jBufTypeCB.addItem("Input");
		jBufTypeCB.addItem("Input_ECL");
		jBufTypeCB.addItem("I/O");
		jBufTypeCB.addItem("I/O_ECL");
		jBufTypeCB.addItem("I/O_open_drain");
		jBufTypeCB.addItem("I/O_open_sink");
		jBufTypeCB.addItem("I/O_open_source");
		jBufTypeCB.addItem("Open_drain");
		jBufTypeCB.addItem("Open_sink");
		jBufTypeCB.addItem("Open_source");
		jBufTypeCB.addItem("Output_ECL");
		jBufTypeCB.addItem("0utput");
		jBufTypeCB.addItem("3-state");
		
		
		/* *****************************************************************
		 *  Fill in the UI values. If an s2i file had already been created *
		 *  in the current project:                                        *
		 *   1. read the values from it.                                   *
		 *   2. Enable/disable the UI appropriately
		 * ****************************************************************/
		if (s2iGlobals.ProjDirFile != null)
		{
            int baseFileNameEnd = s2iGlobals.spiceFileName.lastIndexOf(".");
            if (baseFileNameEnd == -1)
              baseFileNameEnd = s2iGlobals.spiceFileName.length() - 1;
            String spiceFileBase = s2iGlobals.spiceFileName.substring(0, baseFileNameEnd);

    		String s2iFileName = s2iGlobals.ProjDirFile + java.io.File.separator
    		                     + spiceFileBase
    		                     + s2iGlobals.S2I_CMD_FILE_EXTN;
    		importFile(s2iFileName);
    		OnBufTypeSelection();
    	}
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		jImportButton.addActionListener(lSymAction);
		jCancel.addActionListener(lSymAction);
		jOK.addActionListener(lSymAction);
		jBufTypeCB.addActionListener(lSymAction);
		jHelp.addActionListener(lSymAction);
		//}}
	}

	public s2iTransOptions(String sTitle)
	{
		this();
		setTitle(sTitle);
	}

/**
* Constructor with a specified parent window.
*/
  public s2iTransOptions(java.awt.Component parent)
	{
		this();
		this.parent = parent;
		parent.setEnabled(false);
	}

	public void setVisible(boolean b)
	{
		if (b)
        {
			setLocation(50, 50);
            setSize(600,400);
        }
		super.setVisible(b);
	}

	static public void main(String args[])
	{
		(new s2iTransOptions()).setVisible(true);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;
		// Adjust components according to the insets
		setSize(getInsets().left + getInsets().right + d.width, getInsets().top + getInsets().bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(getInsets().left, getInsets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	/** Has addNotify readjusted the layout yet? */
	boolean fComponentsAdjusted = false;
	/** handle so we can block the parent window while we are visible */
	java.awt.Component parent = null;

	//{{DECLARE_CONTROLS
	javax.swing.JPanel jNorthPanel;
	javax.swing.JTabbedPane jCenterPanel;
	javax.swing.JPanel jSouthPanel;
	javax.swing.JLabel jBufTypeLabel;
	javax.swing.JComboBox jBufTypeCB;
	javax.swing.JPanel jPanel4;
	javax.swing.JButton jImportButton;
	javax.swing.JButton jOK;
	javax.swing.JButton jCancel;
	javax.swing.JButton jHelp;
	javax.swing.JPanel jModePanel;
	javax.swing.JPanel jNorthModePanel;
	javax.swing.JLabel jSpiceTypeLabel;
	javax.swing.JTextField jSpiceTypeTF;
	javax.swing.JCheckBox jIterateCheckBox;
	javax.swing.JCheckBox jCleanupCheckBox;
	javax.swing.JCheckBox jSummaryCheckBox;
	javax.swing.JPanel jVOpPanel;
	javax.swing.JLabel jLabel1;
	javax.swing.JPanel jRangePanel;
	javax.swing.JLabel jBlankLabel;
	javax.swing.JLabel jTypLabel;
	javax.swing.JLabel jMinLabel;
	javax.swing.JLabel jMaxLabel;
	javax.swing.JLabel jVRLabel;
	javax.swing.JTextField jVRTypTextField;
	javax.swing.JTextField jVRMinTextField;
	javax.swing.JTextField jVRMaxTextField;
	javax.swing.JPanel jRefPanel;
	javax.swing.JLabel jLabel5;
	javax.swing.JLabel jLabel2;
	javax.swing.JLabel jLabel3;
	javax.swing.JLabel jLabel4;
	javax.swing.JLabel jLabel6;
	javax.swing.JTextField jPullupVtypTF;
	javax.swing.JTextField jPullupVminTF;
	javax.swing.JTextField jPullupVmaxTF;
	javax.swing.JLabel jLabel7;
	javax.swing.JTextField jPulldnVtypTF;
	javax.swing.JTextField jPulldnVminTF;
	javax.swing.JTextField jPulldnVmaxTF;
	javax.swing.JLabel jLabel8;
	javax.swing.JTextField jPclampVtypTF;
	javax.swing.JTextField jPclampVminTF;
	javax.swing.JTextField jPclampVmaxTF;
	javax.swing.JLabel jGClampLabel;
	javax.swing.JTextField jGclampVtypTF;
	javax.swing.JTextField jGclampVminTF;
	javax.swing.JTextField jGclampVmaxTF;
	javax.swing.JPanel jPanel3;
	javax.swing.JPanel jTOpPanel;
	javax.swing.JPanel jTRangePanel;
	javax.swing.JPanel jPanel2;
	javax.swing.JLabel jTRangeLabel;
	javax.swing.JPanel jTBWPanel;
	javax.swing.JLabel jTypLabel1;
	javax.swing.JLabel jBestLabel;
	javax.swing.JLabel jWorstLabel;
	javax.swing.JTextField jTempTtypTF;
	javax.swing.JTextField jTempTminTF;
	javax.swing.JTextField jTempTmaxTF;
	javax.swing.JPanel jNotePanel;
	javax.swing.JTextPane jTextPane1;
	javax.swing.JPanel jStimulusPanel;
	javax.swing.JPanel jPanel5;
	javax.swing.JLabel jSimTimeLabel;
	javax.swing.JTextField jSimTimeTF;
	javax.swing.JPanel jPanel1;
	javax.swing.JPanel jStim11Panel;
	javax.swing.JLabel jRiseTimeLabel;
	javax.swing.JTextField jRiseTimeTF;
	javax.swing.JPanel jStim12Panel;
	javax.swing.JLabel jFallTimeLabel;
	javax.swing.JTextField jFallTimeTF;
	javax.swing.JPanel jStim21Panel;
	javax.swing.JLabel jLowVLabel;
	javax.swing.JTextField jVilTF;
	javax.swing.JPanel jStim22Panel;
	javax.swing.JLabel jHighVLabel;
	javax.swing.JTextField jVihTF;
	javax.swing.JPanel jPanel6;
	javax.swing.JPanel jNodePanel;
	javax.swing.JPanel jLeftNodePanel;
	javax.swing.JPanel jIbisNmPanel;
	javax.swing.JLabel jIbisNmLabel;
	javax.swing.JTextField jIbisTF;
	javax.swing.JPanel jBufPanel;
	javax.swing.JLabel jBufLabel;
	javax.swing.JComboBox jBufCB;
	javax.swing.JPanel jPowNodePanel;
	javax.swing.JLabel jPowNodeLabel;
	javax.swing.JComboBox jPowNodeCB;
	javax.swing.JPanel jGndNodePanel;
	javax.swing.JLabel jGndNodeLabel;
	javax.swing.JComboBox jGndNodeCB;
	javax.swing.JPanel jInNodePanel;
	javax.swing.JLabel jInNodeLabel;
	javax.swing.JComboBox jInNodeCB;
	javax.swing.JPanel jEnNodePanel;
	javax.swing.JLabel jEnNodeLabel;
	javax.swing.JComboBox jEnNodeCB;
	javax.swing.JPanel jRightNodePanel;
	javax.swing.JPanel jModInfoPanel;
	javax.swing.JPanel jModInfoPanel1;
	javax.swing.JLabel jBlankLabel1;
	javax.swing.JLabel jTypLabel2;
	javax.swing.JLabel jMinLabel2;
	javax.swing.JLabel jMaxLabel2;
	javax.swing.JLabel jLowThreshLabel;
	javax.swing.JTextField jLoThreshTypTF;
	javax.swing.JTextField jLoThreshMinTF;
	javax.swing.JTextField jLoThreshMaxTF;
	javax.swing.JLabel jHiThreshLabel;
	javax.swing.JTextField jHiThreshTypTF;
	javax.swing.JTextField jHiThreshMinTF;
	javax.swing.JTextField jHiThreshMaxTF;
	javax.swing.JPanel jModInfoPanel2;
	javax.swing.JLabel jBlankLabel2;
	javax.swing.JLabel jTypLabel3;
	javax.swing.JLabel jMinLabel13;
	javax.swing.JLabel jMaxLabel13;
	javax.swing.JLabel jCcompLabel;
	javax.swing.JTextField jCcompCtypTF;
	javax.swing.JTextField jCcompCminTF;
	javax.swing.JTextField jCcompCmaxTF;
	javax.swing.JPanel jModInfoPanel3;
	javax.swing.JCheckBox jPolarityCB;
	javax.swing.JCheckBox jActiveHighCB;
	javax.swing.JPanel jModInfoPanel4;
	javax.swing.JPanel jDelayPanel;
	javax.swing.JPanel jNWDelayPanel;
	javax.swing.JLabel jDelayBlankLabel;
	javax.swing.JLabel jDelayBlankLabel2;
	javax.swing.JLabel jVmeasLabel;
	javax.swing.JTextField jVmeasTF;
	javax.swing.JLabel jVrefLabel;
	javax.swing.JTextField jVrefTF;
	javax.swing.JLabel jCrefLabel;
	javax.swing.JTextField jCrefTF;
	javax.swing.JLabel jRrefLabel;
	javax.swing.JTextField jRrefTF;
	javax.swing.JPanel jNEDelayPanel;
	javax.swing.JPanel jSouthDelayPanel;
	javax.swing.JPanel jVT1Panel;
	javax.swing.JPanel jRisePanel1;
	javax.swing.JLabel jLabel31;
	javax.swing.JLabel jLabel32;
	javax.swing.JLabel jLabel33;
	javax.swing.JLabel jLabel34;
	javax.swing.JLabel jLabel35;
	javax.swing.JTextField jRwaveVf1TF;
	javax.swing.JTextField jRwaveVfMin1TF;
	javax.swing.JTextField jRwaveVfMax1TF;
	javax.swing.JLabel jLabel36;
	javax.swing.JLabel jLabel37;
	javax.swing.JLabel jLabel38;
	javax.swing.JLabel jLabel39;
	javax.swing.JLabel jLabel40;
	javax.swing.JTextField jRwaveRf1TF;
	javax.swing.JTextField jRwaveLf1TF;
	javax.swing.JTextField jRwaveCf1TF;
	javax.swing.JLabel jLabel41;
	javax.swing.JTextField jRwaveRd1TF;
	javax.swing.JTextField jRwaveLd1TF;
	javax.swing.JTextField jRwaveCd1TF;
	javax.swing.JPanel jFallPanel1;
	javax.swing.JLabel jLabel42;
	javax.swing.JLabel jLabel43;
	javax.swing.JLabel jLabel44;
	javax.swing.JLabel jLabel45;
	javax.swing.JLabel jLabel46;
	javax.swing.JTextField jFwaveVf1TF;
	javax.swing.JTextField jFwaveVfMin1TF;
	javax.swing.JTextField jFwaveVfMax1TF;
	javax.swing.JLabel jLabel47;
	javax.swing.JLabel jLabel48;
	javax.swing.JLabel jLabel49;
	javax.swing.JLabel jLabel50;
	javax.swing.JLabel jLabel51;
	javax.swing.JTextField jFwaveRf1TF;
	javax.swing.JTextField jFwaveLf1TF;
	javax.swing.JTextField jFwaveCf1TF;
	javax.swing.JLabel jLabel52;
	javax.swing.JTextField jFwaveRd1TF;
	javax.swing.JTextField jFwaveLd1TF;
	javax.swing.JTextField jFwaveCd1TF;
	javax.swing.JPanel jVT1BlankPanel;
	javax.swing.JPanel jVT2Panel;
	javax.swing.JPanel jRisePanel2;
	javax.swing.JLabel jLabel9;
	javax.swing.JLabel jLabel10;
	javax.swing.JLabel jLabel11;
	javax.swing.JLabel jLabel12;
	javax.swing.JLabel jLabel13;
	javax.swing.JTextField jRwaveVf2TF;
	javax.swing.JTextField jRwaveVfMin2TF;
	javax.swing.JTextField jRwaveVfMax2TF;
	javax.swing.JLabel jLabel14;
	javax.swing.JLabel jLabel15;
	javax.swing.JLabel jLabel16;
	javax.swing.JLabel jLabel17;
	javax.swing.JLabel jLabel18;
	javax.swing.JTextField jRwaveRf2TF;
	javax.swing.JTextField jRwaveLf2TF;
	javax.swing.JTextField jRwaveCf2TF;
	javax.swing.JLabel jLabel19;
	javax.swing.JTextField jRwaveRd2TF;
	javax.swing.JTextField jRwaveLd2TF;
	javax.swing.JTextField jRwaveCd2TF;
	javax.swing.JPanel jFallPanel2;
	javax.swing.JLabel jLabel20;
	javax.swing.JLabel jLabel21;
	javax.swing.JLabel jLabel22;
	javax.swing.JLabel jLabel23;
	javax.swing.JLabel jLabel24;
	javax.swing.JTextField jFwaveVf2TF;
	javax.swing.JTextField jFwaveVfMin2TF;
	javax.swing.JTextField jFwaveVfMax2TF;
	javax.swing.JLabel jLabel25;
	javax.swing.JLabel jLabel26;
	javax.swing.JLabel jLabel27;
	javax.swing.JLabel jLabel28;
	javax.swing.JLabel jLabel29;
	javax.swing.JTextField jFwaveRf2TF;
	javax.swing.JTextField jFwaveLf2TF;
	javax.swing.JTextField jFwaveCf2TF;
	javax.swing.JLabel jLabel30;
	javax.swing.JTextField jFwaveRd2TF;
	javax.swing.JTextField jFwaveLd2TF;
	javax.swing.JTextField jFwaveCd2TF;
	javax.swing.JPanel jVT2BlankPanel;
	javax.swing.JPanel jRLoadPanel;
	javax.swing.JPanel jRLoadNorthPanel;
	javax.swing.JLabel jRLoadLabel;
	javax.swing.JTextField jRloadTF;
	javax.swing.JLabel jRLoadLabel2;
	javax.swing.JLabel jRLoadLabel3;
	javax.swing.JLabel jRLoadLabel4;
	javax.swing.JLabel jRLoadLabel5;
	javax.swing.JPanel jPostProcPanel;
	javax.swing.JPanel jLPostProcPanel;
	javax.swing.JPanel jDerVIPanel;
	javax.swing.JLabel jDerVILabel;
	javax.swing.JPanel jDerVIRPanel;
	javax.swing.JTextField jDerVITF;
	javax.swing.JLabel jDerVILabel2;
	javax.swing.JPanel jDerRampPanel;
	javax.swing.JLabel jDerRampLabel;
	javax.swing.JPanel jDerRampRPanel;
	javax.swing.JTextField jDerRampTF;
	javax.swing.JLabel jDerRampLabel2;
	javax.swing.JPanel jClampTolPanel;
	javax.swing.JLabel jClampTolLabel;
	javax.swing.JPanel jClampTolRPanel;
	javax.swing.JTextField jClampTolTF;
	javax.swing.JLabel jClampTolLabel2;
	javax.swing.JPanel jRPostProcPanel;
	//}}
	
	//{{Non Symantec  My Controlls 
	s2iData data = new s2iData();
	StringBuffer prevInputNd = new StringBuffer();
	StringBuffer prevEnableNd = new StringBuffer();
	StringBuffer prevSimTime = new StringBuffer();
	StringBuffer prevRiseTime = new StringBuffer();
	StringBuffer prevFallTime = new StringBuffer();
	StringBuffer prevVil = new StringBuffer();
	StringBuffer prevVih = new StringBuffer();
	StringBuffer prevLoThreshTyp = new StringBuffer();
	StringBuffer prevHiThreshTyp = new StringBuffer();
	StringBuffer prevActiveHigh = new StringBuffer();
	StringBuffer prevNonInvert = new StringBuffer();

	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == s2iTransOptions.this)
				JDialog1_WindowClosing(event);
		}
	}

	void JDialog1_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false); // hide the Frame
		dispose();	     // free the system resources
		if (parent == null)
 	        System.exit(0);    // close the application in test mode
		else
	        parent.setEnabled(true);
	}
	
	void createTreeData(DefaultMutableTreeNode top)
	{
	    DefaultMutableTreeNode classification;

	    classification = new DefaultMutableTreeNode("Nodes");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Mode");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Voltage");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Temperature");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Stimulus");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Model Information");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Buffer Delay");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("VT-1");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("VT-2");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Ramp Load");
	    top.add(classification);

	    classification = new DefaultMutableTreeNode("Post Processing");
	    top.add(classification);
	}


	void getUIValues(s2iData data)
	{
	    data.ibsModelType = (String) jBufTypeCB.getSelectedItem();
	    
	    //   NODE
	    data.model_name = jIbisTF.getText();
	    data.ibsFileName = data.model_name + s2iGlobals.IBIS_FILE_EXTN;
	    data.spice_node = (String) jBufCB.getSelectedItem();
	    
	    data.pow_pin = (String) jPowNodeCB.getSelectedItem();
	    data.gnd_pin = (String) jGndNodeCB.getSelectedItem();
	    if (!jInNodeCB.isEnabled())
	    {
	        data.input_pin = null;
	    }
	    else
	    {
	        data.input_pin = (String) jInNodeCB.getSelectedItem();
	    }
	    if (!jEnNodeCB.isEnabled())
	    {
	        data.enable_pin = null;
	    }
	    else
	    {
	        data.enable_pin = (String) jEnNodeCB.getSelectedItem();
	    }
	    
	    

	    //   MODE
	    
	    data.ibsSpiceType = jSpiceTypeTF.getText(); 
	    data.ibsIterate = jIterateCheckBox.isSelected();
	    data.ibsCleanup = jCleanupCheckBox.isSelected(); 
	    data.ibsSummarize = jSummaryCheckBox.isSelected();
	    
	    
	    
	    // Where are fields for "Temperature range" to "Derate ramp" ?
	    
	    
	    
	    //           OPERATING RANGE -> TEMPERATURE
	    /*
	    * Global parameter section parameter - typ package temperature
	    */
	    data.ibsTempTtyp = jTempTtypTF.getText();
	    /*
	    * Global parameter section parameter - min package temperature
	    */
	    data.ibsTempTmin = jTempTminTF.getText();
	    /*
	    * Global parameter section parameter - max package temperature
	    */
	    data.ibsTempTmax = jTempTmaxTF.getText();
	    
	    
	    
	    //           OPERATING RANGE -> VOLTAGE
	    /*
	    * Global parameter section parameter - typ/min/max supply voltage
	    */
	    data.ibsVoltVtyp = jVRTypTextField.getText();
	    data.ibsVoltVmin = jVRMinTextField.getText();
	    data.ibsVoltVmax = jVRMaxTextField.getText();
	    
	    /*
	    * Global parameter section parameter - typ/min/max pull-up voltage
	    */
	    data.ibsPullupVtyp = jPullupVtypTF.getText();
	    data.ibsPullupVmin = jPullupVminTF.getText();
        data.ibsPullupVmax = jPullupVmaxTF.getText();
	    
	    /*
	    * Global parameter section parameter - typ/min/max pull-down voltage
	    */
	    data.ibsPulldnVtyp = jPulldnVtypTF.getText();
	    data.ibsPulldnVmin = jPulldnVminTF.getText();
	    data.ibsPulldnVmax = jPulldnVmaxTF.getText();

	    /*
	    * Global parameter section parameter - typ/min/max power-clamp voltage
	    */
	    data.ibsPclampVtyp = jPclampVtypTF.getText();
	    data.ibsPclampVmin = jPclampVminTF.getText();
	    data.ibsPclampVmax = jPclampVmaxTF.getText();

	    /*
	    * Global parameter section parameter - typ ground-clamp voltage
	    */
	    data.ibsGclampVtyp = jGclampVtypTF.getText();
	    data.ibsGclampVmin = jGclampVminTF.getText();
	    data.ibsGclampVmax = jGclampVmaxTF.getText();
	    
	    
	    
	    //      STIMULUS
	    /*
	    * Global parameter section parameter - typ low stimulus input voltage
	    */
	    if (!jVilTF.isEnabled())
	    {
	        data.ibsVilVtyp = null;
	    }
	    else
	    {
	        data.ibsVilVtyp = jVilTF.getText();
	    }
	    /*
	    * Global parameter section parameter - min low stimulus input voltage
	    */
	    //do nothing with data.ibsVilVmin;
	    /*
	    * Global parameter section parameter - max low stimulus input voltage
	    */
	    //do nothing with data.ibsVilVmax;
	    /*
	    * Global parameter section parameter - typ high stimulus input voltage
	    */
	    if (!jVihTF.isEnabled())
	    {
	        data.ibsVihVtyp = null;
	    }
	    else
	    {
	        data.ibsVihVtyp = jVihTF.getText();
	    }
	    /*
	    * Global parameter section parameter - min high stimulus input voltage
	    */
	    //do nothing with  data.ibsVihVmin;
	    /*
	    * Global parameter section parameter - max high stimulus input voltage
	    */
	    //do nothing with  data.ibsVihVmax;
	    /*
	    * Global parameter section parameter - typ stimulus input voltage risetime
	    */
	    if (!jRiseTimeTF.isEnabled())
	    {
	        data.ibsTrTtyp = null;
	    }
	    else
	    {
	        data.ibsTrTtyp = jRiseTimeTF.getText();
	    }
	    /*
	    * Global parameter section parameter - min stimulus input voltage risetime
	    */
	    // do nothing with data.ibsTrTmin;
	    /*
	    * Global parameter section parameter - max stimulus input voltage risetime
	    */
	    // do nothing with data.ibsTrTmax;
	    /*
	    * Global parameter section parameter - typ stimulus input voltage falltime
	    */
	    if (!jFallTimeTF.isEnabled())
	    {
	        data.ibsTfTtyp = null;
	    }
	    else
	    {
	        data.ibsTfTtyp = jFallTimeTF.getText();
	    }
	    /*
	    * Global parameter section parameter - min stimulus input voltage falltime
	    */
	    // do nothing with data.ibsTfTmin;
	    /*
	    * Global parameter section parameter - max stimulus input voltage falltime
	    */
	    // do nothing with data.ibsTfTmax;
	    /*
	    * Global parameter section parameter - Spice transient simulation time
	    */
	    if (!jSimTimeTF.isEnabled())
	    {
	        data.ibsSimTime = null;
	    }
	    else
	    {
	        data.ibsSimTime = jSimTimeTF.getText();
	    }
	    
	    
	    
	    // RAMP LOAD
	    /*
	    * Global parameter section parameter - load resistance for ramp rate
	    */
	    data.ibsRload = jRloadTF.getText();

	    
	    // POST PROCESSING
	    /*
	    * Global parameter section parameter - threshold for clamp curve printing
	    */
	    data.ibsClampTol = jClampTolTF.getText();
	    /*
	    * Global parameter section parameter - percent to derate VI curves
	    */
	    data.ibsDerateVi = jDerVITF.getText();
	    /*
	    * Global parameter section parameter - percent to derate ramp rates
	    */
	    data.ibsDerateRamp = jDerRampTF.getText();

	    
	    
	    
	    //   MODEL  INFORMATION
	    
	    /*
	    * Model section parameter - polarity
	    */
	    if (!jPolarityCB.isEnabled())
	    {
	        data.ibsPolarity = null;
	    }
	    else if (jPolarityCB.isSelected())
	    {
	        data.ibsPolarity = "Inverting";
	    }
	    else
	    {
	        data.ibsPolarity = "Non-Inverting";
	    }
	    
	    /*
	    * Model section parameter - enable flag
	    */
	    if (!jActiveHighCB.isEnabled())
	    {
	        data.ibsEnable = null;
	    }
	    else if (jActiveHighCB.isSelected())
	    {
	        data.ibsEnable = "Active-High";
	    }
	    else
	    {
	        data.ibsEnable = "Active-Low";
	    }
	     
	    /*
	    * Model section parameter - voltage low vin
	    */
	    if (!jLoThreshTypTF.isEnabled())
	    {
	        data.ibsVin = null;
	    }
	    else
	    {
	        data.ibsVin = jLoThreshTypTF.getText();
	    }
	    /*
	    * Model section parameter - voltage high vin
	    */
	    if (!jHiThreshTypTF.isEnabled())
	    {
	        data.ibsVinh = null;
	    }
	    else
	    {
	        data.ibsVinh = jHiThreshTypTF.getText();
	    }
	    /*
	    * Global parameter section parameter - typ silicon die capacitance
	    */
	    data.ibsCcompCtyp = jCcompCtypTF.getText();
	    /*
	    * Global parameter section parameter - min silicon die capacitance
	    */
	    data.ibsCcompCmin = jCcompCminTF.getText();
	    /*
	    * Global parameter section parameter - max silicon die capacitance
	    */
	    data.ibsCcompCmax = jCcompCmaxTF.getText();
	    
	    
	    
	    //    BUFFER DELAY
	    /*
	    * Model section parameter - voltage mean
	    */
	    data.ibsVmeas = jVmeasTF.getText();
	    /*
	    * Model section parameter - ref capacitance
	    */
	    data.ibsVref = jVrefTF.getText();
	    /*
	    * Model section parameter - ref resistance
	    */
	    data.ibsCref = jCrefTF.getText();
	    /*
	    * Model section parameter - ref voltage
	    */
	    data.ibsRref = jRrefTF.getText();

	    
	    
	    data.RwaveCtr = 0;
	    data.FwaveCtr = 0;
	    //   RISING WAVEFORM 1
	    /*
	    * Model section parameter - rising-wave Vf1
	    */
	    if ((jRwaveVf1TF.getText().trim().equals("")) &&
	        (jRwaveVfMin1TF.getText().trim().equals("")) &&
	        (jRwaveVfMax1TF.getText().trim().equals("")) &&
	        (jRwaveRf1TF.getText().trim().equals("")) &&
	        (jRwaveLf1TF.getText().trim().equals("")) &&
	        (jRwaveCf1TF.getText().trim().equals("")) &&
	        (jRwaveRd1TF.getText().trim().equals("")) &&
	        (jRwaveCd1TF.getText().trim().equals("")) &&
	        (jRwaveLd1TF.getText().trim().equals("")))
	        {
	            //No entry for Rising Wave form 1 - leave it
	        }
	    else{
        	    data.ibsRwaveVf[data.RwaveCtr] = jRwaveVf1TF.getText();
        	    data.ibsRwaveVfMin[data.RwaveCtr] = jRwaveVfMin1TF.getText();
        	    data.ibsRwaveVfMax[data.RwaveCtr] = jRwaveVfMax1TF.getText();
        	    data.ibsRwaveRf[data.RwaveCtr] = jRwaveRf1TF.getText();
        	    data.ibsRwaveLf[data.RwaveCtr] = jRwaveLf1TF.getText();
        	    data.ibsRwaveCf[data.RwaveCtr] = jRwaveCf1TF.getText();
        	    data.ibsRwaveRd[data.RwaveCtr] = jRwaveRd1TF.getText();
        	    data.ibsRwaveCd[data.RwaveCtr] = jRwaveCd1TF.getText();
        	    data.ibsRwaveLd[data.RwaveCtr] = jRwaveLd1TF.getText();
        	    data.RwaveCtr++;
	        }
	    
	    /*
	    * Model section parameter - falling-wave Vf1
	    */
	    if ((jFwaveVf1TF.getText().trim().equals("")) &&
	        (jFwaveVfMin1TF.getText().trim().equals("")) &&
	        (jFwaveVfMax1TF.getText().trim().equals("")) &&
	        (jFwaveRf1TF.getText().trim().equals("")) &&
	        (jFwaveLf1TF.getText().trim().equals("")) &&
	        (jFwaveCf1TF.getText().trim().equals("")) &&
	        (jFwaveRd1TF.getText().trim().equals("")) &&
	        (jFwaveCd1TF.getText().trim().equals("")) &&
	        (jFwaveLd1TF.getText().trim().equals("")))
	        {
	            //No entry for Falling Wave form 1 - leave it
	        }
	    else{
        	    data.ibsFwaveVf[data.FwaveCtr] = jFwaveVf1TF.getText();
        	    data.ibsFwaveVfMin[data.FwaveCtr] = jFwaveVfMin1TF.getText();
        	    data.ibsFwaveVfMax[data.FwaveCtr] = jFwaveVfMax1TF.getText();
        	    data.ibsFwaveRf[data.FwaveCtr] = jFwaveRf1TF.getText();
        	    data.ibsFwaveLf[data.FwaveCtr] = jFwaveLf1TF.getText();
        	    data.ibsFwaveCf[data.FwaveCtr] = jFwaveCf1TF.getText();
        	    data.ibsFwaveRd[data.FwaveCtr] = jFwaveRd1TF.getText();
        	    data.ibsFwaveCd[data.FwaveCtr] = jFwaveCd1TF.getText();
        	    data.ibsFwaveLd[data.FwaveCtr] = jFwaveLd1TF.getText();
        	    data.FwaveCtr++;
            }
	    
	    
	    //   RISING WAVEFORM 2
	    /*
	    * Model section parameter - rising-wave Vf2
	    */
	    if ((jRwaveVf2TF.getText().trim().equals("")) &&
	        (jRwaveVfMin2TF.getText().trim().equals("")) &&
	        (jRwaveVfMax2TF.getText().trim().equals("")) &&
	        (jRwaveRf2TF.getText().trim().equals("")) &&
	        (jRwaveLf2TF.getText().trim().equals("")) &&
	        (jRwaveCf2TF.getText().trim().equals("")) &&
	        (jRwaveRd2TF.getText().trim().equals("")) &&
	        (jRwaveCd2TF.getText().trim().equals("")) &&
	        (jRwaveLd2TF.getText().trim().equals("")))
	        {
	            //No entry for Rising Wave form 2 - leave it
	        }
	    else{
        	    data.ibsRwaveVf[data.RwaveCtr] = jRwaveVf2TF.getText();
        	    data.ibsRwaveVfMin[data.RwaveCtr] = jRwaveVfMin2TF.getText();
        	    data.ibsRwaveVfMax[data.RwaveCtr] = jRwaveVfMax2TF.getText();
        	    data.ibsRwaveRf[data.RwaveCtr] = jRwaveRf2TF.getText();
        	    data.ibsRwaveLf[data.RwaveCtr] = jRwaveLf2TF.getText();
        	    data.ibsRwaveCf[data.RwaveCtr] = jRwaveCf2TF.getText();
        	    data.ibsRwaveRd[data.RwaveCtr] = jRwaveRd2TF.getText();
        	    data.ibsRwaveCd[data.RwaveCtr] = jRwaveCd2TF.getText();
        	    data.ibsRwaveLd[data.RwaveCtr] = jRwaveLd2TF.getText();
	            data.RwaveCtr++;
            }
	    
	    /*
	    * Model section parameter - falling-wave Vf2
	    */
	    if ((jFwaveVf2TF.getText().trim().equals("")) &&
	        (jFwaveVfMin2TF.getText().trim().equals("")) &&
	        (jFwaveVfMax2TF.getText().trim().equals("")) &&
	        (jFwaveRf2TF.getText().trim().equals("")) &&
	        (jFwaveLf2TF.getText().trim().equals("")) &&
	        (jFwaveCf2TF.getText().trim().equals("")) &&
	        (jFwaveRd2TF.getText().trim().equals("")) &&
	        (jFwaveCd2TF.getText().trim().equals("")) &&
	        (jFwaveLd2TF.getText().trim().equals("")))
	        {
	            //No entry for Falling Wave form 2 - leave it
	        }
	    else{
        	    data.ibsFwaveVf[data.FwaveCtr] = jFwaveVf2TF.getText();
        	    data.ibsFwaveVfMin[data.FwaveCtr] = jFwaveVfMin2TF.getText();
        	    data.ibsFwaveVfMax[data.FwaveCtr] = jFwaveVfMax2TF.getText();
        	    data.ibsFwaveRf[data.FwaveCtr] = jFwaveRf2TF.getText();
        	    data.ibsFwaveLf[data.FwaveCtr] = jFwaveLf2TF.getText();
        	    data.ibsFwaveCf[data.FwaveCtr] = jFwaveCf2TF.getText();
        	    data.ibsFwaveRd[data.FwaveCtr] = jFwaveRd2TF.getText();
        	    data.ibsFwaveCd[data.FwaveCtr] = jFwaveCd2TF.getText();
        	    data.ibsFwaveLd[data.FwaveCtr] = jFwaveLd2TF.getText();
        	    data.FwaveCtr++;
            }
	    
	  
	    
	    
	}
	
	
	void FillUIValues(s2iData data)
	{
	    if ((data.ibsModelType == null) ||
	        (data.ibsModelType.trim().equals("")))
	    {
	        jBufTypeCB.setSelectedItem("I/O");
	    }
	    else
	    {
	        jBufTypeCB.setSelectedItem(data.ibsModelType);
	    }
	    
	    //   NODE
	    jIbisTF.setText(data.model_name);
	    jInNodeCB.setSelectedItem(data.input_pin);
	    jPowNodeCB.setSelectedItem(data.pow_pin);
	    jGndNodeCB.setSelectedItem(data.gnd_pin);
	    jBufCB.setSelectedItem(data.spice_node);
	    jEnNodeCB.setSelectedItem(data.enable_pin);
	    
	    
	    
	    //   MODE
	    /*
	    * Header section parameter - spice type
	    */
	    jSpiceTypeTF.setText(data.ibsSpiceType);
	    /*
	    * Header section parameter - iterate flag
	    */
	    jIterateCheckBox.setSelected(data.ibsIterate);
	    
	    /*
	    * Header section parameter - cleanup flag
	    */
	    jCleanupCheckBox.setSelected(data.ibsCleanup);
	    
	    /*
	    * Header section parameter - summarize flag
	    */
	    jSummaryCheckBox.setSelected(data.ibsSummarize);
	    
	    
	    
	    // Where are fields for "Temperature range" to "Derate ramp" ?

	    
	    
	    //           OPERATING RANGE -> TEMPERATURE
	    /*
	    * Global parameter section parameter - typ package temperature
	    */
	    jTempTtypTF.setText(data.ibsTempTtyp);
	    /*
	    * Global parameter section parameter - min package temperature
	    */
	    jTempTminTF.setText(data.ibsTempTmin);
	    /*
	    * Global parameter section parameter - max package temperature
	    */
	    jTempTmaxTF.setText(data.ibsTempTmax);
	    
	    
	    
	    //           OPERATING RANGE -> VOLTAGE
	    /*
	    * Global parameter section parameter - typ supply voltage
	    */
	    jVRTypTextField.setText(data.ibsVoltVtyp);
	    /*
	    * Global parameter section parameter - min supply voltage
	    */
	    jVRMinTextField.setText(data.ibsVoltVmin);
	    /*
	    * Global parameter section parameter - max supply voltage
	    */
	    jVRMaxTextField.setText(data.ibsVoltVmax);

	    /*
	    * Global parameter section parameter - typ pull-up voltage
	    */
	    jPullupVtypTF.setText(data.ibsPullupVtyp);
	    /*
	    * Global parameter section parameter - min pull-up voltage
	    */
	    jPullupVminTF.setText(data.ibsPullupVmin);
	    /*
	    * Global parameter section parameter - max pull-up voltage
	    */
	    jPullupVmaxTF.setText(data.ibsPullupVmax);
	    
	    /*
	    * Global parameter section parameter - typ pull-down voltage
	    */
	    jPulldnVtypTF.setText(data.ibsPulldnVtyp);
	    /*
	    * Global parameter section parameter - min pull-down voltage
	    */
	    jPulldnVminTF.setText(data.ibsPulldnVmin);
	    /*
	    * Global parameter section parameter - max pull-down voltage
	    */
	    jPulldnVmaxTF.setText(data.ibsPulldnVmax);
	    
	    /*
	    * Global parameter section parameter - typ power-clamp voltage
	    */
	    jPclampVtypTF.setText( data.ibsPclampVtyp);
	    /*
	    * Global parameter section parameter - min power-clamp voltage
	    */
	    jPclampVminTF.setText( data.ibsPclampVmin);
	    /*
	    * Global parameter section parameter - max power-clamp voltage
	    */
	    jPclampVmaxTF.setText( data.ibsPclampVmax);
	    
	    /*
	    * Global parameter section parameter - typ ground-clamp voltage
	    */
	    jGclampVtypTF.setText( data.ibsGclampVtyp);
	    /*
	    * Global parameter section parameter - min ground-clamp voltage
	    */
	    jGclampVminTF.setText( data.ibsGclampVmin);
	    /*
	    * Global parameter section parameter - max ground-clamp voltage
	    */
	    jGclampVmaxTF.setText( data.ibsGclampVmax);
	    

	    
	    //      STIMULUS
	    /*
	    * Global parameter section parameter - typ low stimulus input voltage
	    */
	    jVilTF.setText(data.ibsVilVtyp);
	    /*
	    * Global parameter section parameter - min low stimulus input voltage
	    */
	    //do nothing with data.ibsVilVmin;
	    /*
	    * Global parameter section parameter - max low stimulus input voltage
	    */
	    //do nothing with data.ibsVilVmax;
	    /*
	    * Global parameter section parameter - typ high stimulus input voltage
	    */
	    jVihTF.setText(data.ibsVihVtyp);
	    /*
	    * Global parameter section parameter - min high stimulus input voltage
	    */
	    //do nothing with  data.ibsVihVmin;
	    /*
	    * Global parameter section parameter - max high stimulus input voltage
	    */
	    //do nothing with  data.ibsVihVmax;
	    /*
	    * Global parameter section parameter - typ stimulus input voltage risetime
	    */
	    jRiseTimeTF.setText(data.ibsTrTtyp);
	    /*
	    * Global parameter section parameter - min stimulus input voltage risetime
	    */
	    // do nothing with data.ibsTrTmin;
	    /*
	    * Global parameter section parameter - max stimulus input voltage risetime
	    */
	    // do nothing with data.ibsTrTmax;
	    /*
	    * Global parameter section parameter - typ stimulus input voltage falltime
	    */
	    jFallTimeTF.setText(data.ibsTfTtyp);
	    /*
	    * Global parameter section parameter - min stimulus input voltage falltime
	    */
	    // do nothing with data.ibsTfTmin;
	    /*
	    * Global parameter section parameter - max stimulus input voltage falltime
	    */
	    // do nothing with data.ibsTfTmax;
	    /*
	    * Global parameter section parameter - Spice transient simulation time
	    */
	    jSimTimeTF.setText(data.ibsSimTime);
	    
	    
	    
	    // RAMP LOAD
	    /*
	    * Global parameter section parameter - load resistance for ramp rate
	    */
	    jRloadTF.setText( data.ibsRload);
	    

	    // POST PROCESSING
	    /*
	    * Global parameter section parameter - threshold for clamp curve printing
	    */
	    jClampTolTF.setText( data.ibsClampTol);
	    /*
	    * Global parameter section parameter - percent to derate VI curves
	    */
	    jDerVITF.setText( data.ibsDerateVi);
	    /*
	    * Global parameter section parameter - percent to derate ramp rates
	    */
	    jDerRampTF.setText( data.ibsDerateRamp);
	    
	    
	    

	    //   MODEL  INFORMATION
	    
	    /*
	    * Model section parameter - polarity
	    */
	    if ( (data.ibsPolarity != null) && (data.ibsPolarity.equalsIgnoreCase("Non-Inverting")) )
	    {
	        jPolarityCB.setSelected(false);
	    }
	    else
	    {
	        jPolarityCB.setSelected(true);
	    }
	    
	    /*
	    * Model section parameter - enable flag
	    */
	    //data.ibsEnable = (jActiveHighCB.isSelected()) ? "Active-High" : "Active-Low";
	    if ((data.ibsEnable != null) && (data.ibsEnable.equalsIgnoreCase("Active-High")))
	    {
	        jActiveHighCB.setSelected(true);
	    }
	    else
	    {
	        jActiveHighCB.setSelected(false);
	    }
	     
	    /*
	    * Model section parameter - voltage low vin
	    */
	    jLoThreshTypTF.setText(data.ibsVin);
	    /*
	    * Model section parameter - voltage high vin
	    */
	    jHiThreshTypTF.setText(data.ibsVinh);
	    /*
	    * Global parameter section parameter - typ silicon die capacitance
	    */
	    jCcompCtypTF.setText(data.ibsCcompCtyp);
	    /*
	    * Global parameter section parameter - min silicon die capacitance
	    */
	    jCcompCminTF.setText(data.ibsCcompCmin);
	    /*
	    * Global parameter section parameter - max silicon die capacitance
	    */
	    jCcompCmaxTF.setText(data.ibsCcompCmax);
	    
	    
	    
	    //    BUFFER DELAY
	    /*
	    * Model section parameter - voltage mean
	    */
	    jVmeasTF.setText( data.ibsVmeas);
	    /*
	    * Model section parameter - ref capacitance
	    */
	    jVrefTF.setText( data.ibsVref);
	    /*
	    * Model section parameter - ref resistance
	    */
	    jCrefTF.setText( data.ibsCref);
	    /*
	    * Model section parameter - ref voltage
	    */
	     jRrefTF.setText( data.ibsRref);
	    /*
	    
	    
	    //   RISING WAVEFORM 1
	    /*
	    * Model section parameter - rising-wave Vf1
	    */
	    jRwaveVf1TF.setText( data.ibsRwaveVf[0]);
	    jRwaveVfMin1TF.setText( data.ibsRwaveVfMin[0]);
	    jRwaveVfMax1TF.setText( data.ibsRwaveVfMax[0]);
	    jRwaveRf1TF.setText( data.ibsRwaveRf[0]);
	    jRwaveLf1TF.setText( data.ibsRwaveLf[0]);
	    jRwaveCf1TF.setText( data.ibsRwaveCf[0]);
	    jRwaveRd1TF.setText( data.ibsRwaveRd[0]);
	    jRwaveCd1TF.setText( data.ibsRwaveCd[0]);
	    jRwaveLd1TF.setText( data.ibsRwaveLd[0]);
	    
	    /*
	    * Model section parameter - falling-wave Vf1
	    */
	    jFwaveVf1TF.setText( data.ibsFwaveVf[0]);
	    jFwaveVfMin1TF.setText( data.ibsFwaveVfMin[0]);
	    jFwaveVfMax1TF.setText( data.ibsFwaveVfMax[0]);
	    jFwaveRf1TF.setText( data.ibsFwaveRf[0]);
	    jFwaveLf1TF.setText( data.ibsFwaveLf[0]);
	    jFwaveCf1TF.setText( data.ibsFwaveCf[0]);
	    jFwaveRd1TF.setText( data.ibsFwaveRd[0]);
	    jFwaveCd1TF.setText( data.ibsFwaveCd[0]);
	    jFwaveLd1TF.setText( data.ibsFwaveLd[0]);
	    
	    
	    //   RISING WAVEFORM 2
	    /*
	    * Model section parameter - rising-wave Vf2
	    */
	    jRwaveVf2TF.setText( data.ibsRwaveVf[1]);
	    jRwaveVfMin2TF.setText( data.ibsRwaveVfMin[1]);
	    jRwaveVfMax2TF.setText( data.ibsRwaveVfMax[1]);
	    jRwaveRf2TF.setText( data.ibsRwaveRf[1]);
	    jRwaveLf2TF.setText( data.ibsRwaveLf[1]);
	    jRwaveCf2TF.setText( data.ibsRwaveCf[1]);
	    jRwaveRd2TF.setText( data.ibsRwaveRd[1]);
	    jRwaveCd2TF.setText( data.ibsRwaveCd[1]);
	    jRwaveLd2TF.setText( data.ibsRwaveLd[1]);
	    
	    /*
	    * Model section parameter - falling-wave Vf2
	    */
	    jFwaveVf2TF.setText( data.ibsFwaveVf[1]);
	    jFwaveVfMin2TF.setText( data.ibsFwaveVfMin[1]);
	    jFwaveVfMax2TF.setText( data.ibsFwaveVfMax[1]);
	    jFwaveRf2TF.setText( data.ibsFwaveRf[1]);
	    jFwaveLf2TF.setText( data.ibsFwaveLf[1]);
	    jFwaveCf2TF.setText( data.ibsFwaveCf[1]);
	    jFwaveRd2TF.setText( data.ibsFwaveRd[1]);
	    jFwaveCd2TF.setText( data.ibsFwaveCd[1]);
	    jFwaveLd2TF.setText( data.ibsFwaveLd[1]);



	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == jImportButton)
				jImportButton_actionPerformed(event);
			else if (object == jCancel)
				jCancel_actionPerformed(event);
			else if (object == jOK)
				jOK_actionPerformed(event);
			else if (object == jBufTypeCB)
				jBufTypeCB_actionPerformed(event);
			else if (object == jHelp)
				s2iMain.showHelp();
		}
	}


    void importFile(String fileName)
    {
        java.io.File s2iFile = new java.io.File(fileName);
		if ( (s2iFile.exists()) && (s2iFile.isFile()) && (s2iFile.canRead()) )
		{
		    s2iReader Rdr = new s2iReader();
		    Rdr.Sp2iParse(s2iFile.toString(), data);
		}

		// Whether or not the Model Files were imported, SpiTran creates its
		// own Model files.
		data.ibsModelFiletyp = s2iGlobals.TypModelFileName;
		data.ibsModelFilemin = s2iGlobals.MinModelFileName;
		data.ibsModelFilemax = s2iGlobals.MaxModelFileName;
		
		FillUIValues(data);
	}

	void jImportButton_actionPerformed(java.awt.event.ActionEvent event)
	{
		JFileChooser importBrowser = new JFileChooser(".");
		importBrowser.setApproveButtonText("  OK  ");
		importBrowser.setDialogTitle("Import s2i File");
		int retVal = importBrowser.showOpenDialog(this);
		if (retVal == JFileChooser.APPROVE_OPTION)
		{
		   java.io.File selection = importBrowser.getSelectedFile();
           String path = new String("");
		   try
		   {
		      path = selection.getCanonicalPath();
		   }
		   catch(java.io.IOException ioe)
		   {
		      path = selection.getAbsolutePath();
		   }

           if(path != "")
           {
        	 	importFile(path);
                String msg = new String("Imported ");
                msg = msg + path;
                s2iError.PrintMsg(msg, s2iError.INFO,
                    s2iError.LOG | s2iError.DISPLAY, null);
           }
		}
	}

	void jCancel_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		/* Cancel this form */
		java.awt.AWTEvent e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
		dispatchEvent(e);
	}

	void jOK_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		//Hard code
		data.ibsVersion = "2.1";
		data.ibsFileRev = "0.1";
		data.ibsComponent = "Component-Name";
		data.ibsManufacturer = "Manufacturer-Name";
		
		// Put the UI values in the data structure
		getUIValues(data);
		
		//other info
		data.ibsSpiceFile = s2iGlobals.spiceFileName;
		DateFormat df = DateFormat.getDateInstance();
		Date date = new Date();
		data.ibsDate = df.format(date);
		
		// Write out the data
		if (s2iGlobals.ProjDirFile != null)
		{
            int baseFileNameEnd = s2iGlobals.spiceFileName.lastIndexOf(".");
            if (baseFileNameEnd == -1)
              baseFileNameEnd = s2iGlobals.spiceFileName.length() - 1;
            String spiceFileBase = s2iGlobals.spiceFileName.substring(0, baseFileNameEnd);
    		String s2iFileName = s2iGlobals.ProjDirFile + java.io.File.separator
    		                     + spiceFileBase
    		                     + s2iGlobals.S2I_CMD_FILE_EXTN;
    		s2iWriter Wtr = new s2iWriter();
    		try{
    		    Wtr.outputS2i(s2iFileName, data, false);
    		}
    		catch (java.io.IOException ioe)
    		{
    		    String Msg = ioe.getMessage();
    		    s2iError.PrintMsg( Msg, s2iError.ERR, s2iError.POPUP | 
    		                         s2iError.LOG | s2iError.DISPLAY,this);
    		}
		}
		java.awt.AWTEvent e = new java.awt.event.WindowEvent(this, java.awt.event.WindowEvent.WINDOW_CLOSING);
		dispatchEvent(e);
	}

    private void comboDisable(JComboBox cb, StringBuffer bakup)
    {
        if (cb.isEnabled())
        {
            bakup.setLength(0);
            bakup.append((String) cb.getSelectedItem());
            cb.setSelectedItem("");
            cb.setEnabled(false);
        }
    }
    
    private void comboEnable(JComboBox cb, StringBuffer bakup)
    {
        if (!cb.isEnabled())
		{
   		    cb.setSelectedItem(bakup.toString());
   		    cb.setEnabled(true);
        }
    }
    
    private void textFieldDisable(JTextField tf, StringBuffer bakup)
    {
        if (tf.isEnabled())
        {
            bakup.setLength(0);
            bakup.append((String) tf.getText());
            tf.setText("");
            tf.setEnabled(false);
        }
    }

    private void textFieldEnable(JTextField tf, StringBuffer bakup)
    {
        if (!tf.isEnabled())
		{
   		    tf.setText(bakup.toString());
   		    tf.setEnabled(true);
        }
    }


    private void checkBoxDisable(JCheckBox chb, StringBuffer bakup)
    {
        if (chb.isEnabled())
        {
            boolean b;
            bakup.setLength(0);
            b = chb.isSelected() ? true : false;
            bakup.append( (new Boolean(b)).toString());
            chb.setSelected(false);
            chb.setEnabled(false);
        }
    }
    
    private void checkBoxEnable(JCheckBox chb, StringBuffer bakup)
    {
        if (!chb.isEnabled())
		{
   		    chb.setSelected(Boolean.valueOf(bakup.toString()).booleanValue());
   		    chb.setEnabled(true);
        }
    }


    private void OnBufTypeSelection()
    {
        String bufType = (String) jBufTypeCB.getSelectedItem();
        //enable/disable fields
		if (bufType.startsWith("Input"))
		{
		    comboDisable(jInNodeCB, prevInputNd);
		    comboDisable(jEnNodeCB, prevEnableNd);
		    textFieldDisable(jSimTimeTF, prevSimTime);
		    textFieldDisable(jRiseTimeTF, prevRiseTime);
		    textFieldDisable(jFallTimeTF, prevFallTime);
		    textFieldDisable(jVilTF, prevVil);
		    textFieldDisable(jVihTF, prevVih);		
		    textFieldEnable(jLoThreshTypTF, prevLoThreshTyp);
		    textFieldEnable(jHiThreshTypTF, prevHiThreshTyp);
		    checkBoxDisable(jActiveHighCB, prevActiveHigh);
		    checkBoxDisable(jPolarityCB, prevNonInvert);
		}
		if (bufType.startsWith("Output") || bufType.startsWith("Open"))
		{
		    comboEnable(jInNodeCB, prevInputNd);
		    comboDisable(jEnNodeCB, prevEnableNd);
		    textFieldEnable(jSimTimeTF, prevSimTime);
		    textFieldEnable(jRiseTimeTF, prevRiseTime);
		    textFieldEnable(jFallTimeTF, prevFallTime);
		    textFieldEnable(jVilTF, prevVil);
		    textFieldEnable(jVihTF, prevVih);
		    textFieldDisable(jLoThreshTypTF, prevLoThreshTyp);
		    textFieldDisable(jHiThreshTypTF, prevHiThreshTyp);
		    checkBoxDisable(jActiveHighCB, prevActiveHigh);
		    checkBoxEnable(jPolarityCB, prevNonInvert);
		}
		if (bufType.startsWith("I/O"))
		{
		    comboEnable(jInNodeCB, prevInputNd);
		    comboEnable(jEnNodeCB, prevEnableNd);
		    textFieldEnable(jSimTimeTF, prevSimTime);
		    textFieldEnable(jRiseTimeTF, prevRiseTime);
		    textFieldEnable(jFallTimeTF, prevFallTime);
		    textFieldEnable(jVilTF, prevVil);
		    textFieldEnable(jVihTF, prevVih);
		    textFieldEnable(jLoThreshTypTF, prevLoThreshTyp);
		    textFieldEnable(jHiThreshTypTF, prevHiThreshTyp);
		    checkBoxEnable(jActiveHighCB, prevActiveHigh);
		    checkBoxEnable(jPolarityCB, prevNonInvert);
		}
		if (bufType.startsWith("3-state"))
		{
		    comboEnable(jInNodeCB, prevInputNd);
		    comboEnable(jEnNodeCB, prevEnableNd);
		    textFieldEnable(jSimTimeTF, prevSimTime);
		    textFieldEnable(jRiseTimeTF, prevRiseTime);
		    textFieldEnable(jFallTimeTF, prevFallTime);
		    textFieldEnable(jVilTF, prevVil);
		    textFieldEnable(jVihTF, prevVih);
		    textFieldDisable(jLoThreshTypTF, prevLoThreshTyp);
		    textFieldDisable(jHiThreshTypTF, prevHiThreshTyp);
		    checkBoxEnable(jActiveHighCB, prevActiveHigh);
		    checkBoxEnable(jPolarityCB, prevNonInvert);
		}
	}
	
	void jBufTypeCB_actionPerformed(java.awt.event.ActionEvent event)
	{
		// to do: code goes here.
		JComboBox cb = (JComboBox) event.getSource();
		String bufType = (String) cb.getSelectedItem();
		
		OnBufTypeSelection();
	}

	
}
